<?php 
if (!isset($docroot)) {
    $docroot = realpath(dirname(__FILE__))."/";
    $docroot = str_ireplace(array('_system/', '\\'), array('', '/'), $docroot);
    define("DOCROOT", $docroot);
}

// myecho('included: '. __FILE__);

if (!function_exists('get_kategorie_array_live')) {
    function get_kategorie_array_live($update) {
        global $CONFIG,$kategorie,$system;
        if (isset($CONFIG['DEVELOPMENT']) && $CONFIG['DEVELOPMENT']) {
            // echo('<div style="color:#FFF;">Fetch data</div>');
        }
        $timestamp_fetch_file = $CONFIG['TEMPDIR'].'timestamp_fetch.txt';
        $time_diff = 1200;
        $last_update_time = 0;
        if (is_file($timestamp_fetch_file) && filesize($timestamp_fetch_file) > 0) {
            $fp = fopen($timestamp_fetch_file, 'r');
            $last_update_time = trim(str_replace("\n", "", fread($fp, filesize($timestamp_fetch_file))));
            fclose($fp);
            if (!is_numeric($last_update_time) || $last_update_time < 0) {
                $last_update_time = 0;
            }
            if (isset($CONFIG['DEVELOPMENT']) && $CONFIG['DEVELOPMENT']) {
                // echo('<div style="color:#FFF;">'.$timestamp_fetch_file. ' found</div>');
            }
        }
        $set_kategorie = 0;
        $CONFIG['MAXFETCH'] = 20;
        if ($update < 1) {
            $CONFIG['MAXFETCH'] = 200;
        }
        $do_fetch = false;
        if (time() - $last_update_time > $time_diff) {
            $do_fetch = true;
        }
        if (!file_exists($CONFIG['TEMPDIR']."cam.s")) {
            updatecam(); // Vielleicht sind ja Daten da.
            if (!file_exists($CONFIG['TEMPDIR']."cam.s")) {
                $cam = array();
            } else {
                $cam = unserialize(implode("", file($CONFIG['TEMPDIR']."cam.s")));
            }
        } else {
            $cam = unserialize(implode("", file($CONFIG['TEMPDIR']."cam.s")));
        }
        $disabled = array();
        if (file_exists($CONFIG['TEMPDIR']."disabled.s")) {
            $disabled = unserialize(implode("", file($CONFIG['TEMPDIR']."disabled.s")));
        }
        // Wenn es Zeit ist, hole alle Kategorien ab, sortiere sie und speichere sie ab.
        // $system['lastrequest'] = 0;
        if ($do_fetch) {
            $set_kategorie = 1;
            if (!isset($system['lastrequest'])) {
                $system['lastrequest'] = 0;
            }
            // Wenn die Differenz zu groesser ist, muessen auch viel mehr Cams geholt werden
            $diff = time() - ($system['lastrequest'] + (60 * $CONFIG['MINUTESLIVINGCAT']));
            if ($diff > (60 * 60 * 6)) {
                $CONFIG['MAXFETCH'] = 200;
            }
            // myecho(count($kategorie));
            for ($catid = 0; $catid < count($kategorie); $catid++) {
                // myecho($catid);
                $save_category_file = false;
                if (!isset($kategorie[$catid]['bezeichnung']) || $kategorie[$catid]['bezeichnung'] == "") {
                    continue;
                }
                // myecho($kategorie[$catid]['bezeichnung']);
                // erst einmal die lokalen XML-Dateien mit den Kategorien abfragen
                // sofern vorhanden und nicht aelter als $file_life_time
                $xml_file = $CONFIG['TEMPDIR'].'kategorie-'.$catid.'.xml';
                // myecho($xml_file);
                if ($do_fetch) {
                    $log_text = null;
                    if (is_file($xml_file) && time() - filemtime($xml_file) < 1200) {
                        // myecho('local category_xml_file:'. $xml_file);
                        // myecho($dateibuffer);
                        // myecho(time() - filemtime($xml_file));
                        // myecho($xml_file);
                        // die();
                        // Wenn Daten kommen, dann wegen language sortieren.
                        $dateibuffer = file_get_contents($xml_file);
                    } else {
                        $remote_file = 'http://remote.777live.com/scriptservice.php?lang='.$CONFIG['LANGUAGE'].'&affiliateid='.$CONFIG["WMID"].'&action=online&categoryid='.$catid.'&type=xml&size=l&camlimit=0&camlist='.$CONFIG['FAVORITEN'].'&host='.urlencode($_SERVER['HTTP_HOST']).'&version='.$CONFIG['VERSION'].".".$CONFIG['BUILD'];
                        // myecho($remote_file); die();
                        $dateibuffer = get_content($remote_file);
                    }
                    if (strlen($dateibuffer) > 0) {
                        // myecho($dateibuffer);die();
                        // Wenn Daten kommen, dann wegen language sortieren.
                        $array = xml2array($dateibuffer);
                        // Pruefen, ob alles okay ist.
                        if (isset($array['INFO']) && $array['INFO'] != "") {
                            // Hoppla, da laeuft etwas verkehrt
                            $log_text = "Result: ".$array['RESULT']."\n<br />Info: ".$array['INFO'];
                        } elseif ($catid == 0 && ((is_array($array['ID'] && count($array['ID']) < 1)) || !is_array($array['ID']))) {
                            $log_text = "Es kommen keine Cams vom 777live-Server.";
                        }
                    } else {
                        $log_text = "Es kommen keine Daten vom 777live-Server.";
                    }
                    if (!is_null($log_text)) {
                        savelog($log_text);
                        // $timestamp_fetch_file aktuelle Zeit - 15 Minuten eintragen
                        // damit erst nach 5 Minuten ein neuer Aufruf an remote gesendet werden kann
                        $time = time() - 1800;
                        file_put_contents($timestamp_fetch_file, $time);
                        return false;
                    }
                    $save_category_file = true;
                    if (is_file($xml_file)) {
                        unlink($xml_file);
                    }
                }
                if (isset($array['ID']) && !is_array($array['ID'])) {
                    // myecho('CategoryId: '.$catid);
                    // myecho($array);
                    $new_array = array();
                    foreach ($array as $key=>$value) {
                        $new_array[$key] = array($value);
                    }
                    $array = $new_array;
                    // myecho($array);
                } else {
                    // myecho('alles OK in CategorId: '.$catid);
                }
                // sortieren
                $array = sort_language($array, $catid);
                if ($catid == 0) {
                    // Hier gilt etwas besonderes
                    if (is_array($array)) {
                        if ($save_category_file) {
                            // system.s speichern
                            $system['lastrequest'] = time();
                            savesystem();
                        }
                        // Alles okay, speichern und cam fuetteren
                        // saveanzahl(count($array['ID']), 0);
                        if ($save_category_file) {
                            if (!savefile("kategorie-{$catid}.xml", "TEMPDIR", $dateibuffer)) {
                                die("Datei konnte nicht gespeichert werden, bitte pruefen Sie die Verzeichnisrechte von ".$CONFIG["TEMP"]);
                            }
                            unset($dateibuffer);
                            if (!savefile("kategorie-{$catid}.s", "TEMPDIR", serialize($array))) {
                                die("Datei konnte nicht gespeichert werden, bitte prüfen Sie die Verzeichnisrechte von ".$CONFIG["TEMP"]);
                            }
                        }
                        for ($n = 0; $n < count($array['ID']); $n++) {
                            // Cam vorhanden?
                            $camid = $array['ID'][$n];
                            if (isset($disabled[$camid]) && $disabled[$camid] == "x") {
                                continue;
                            }
                            if (isset($cam[$camid]) && is_array($cam[$camid])) {
                                // echo $camid."  ".$cam[$camid]['LASTMODIFIED']."   ".$array['LASTMODIFIED'][$n]."\n";
                                $cam[$camid]['SHOWDETAILS'] = $array['SHOWDETAILS'][$n];
                                $cam[$camid]['LASTONLINE'] = time();
                                if ($cam[$camid]['LASTMODIFIED'] < $array['LASTMODIFIED'][$n]) {
                                    savelog("Camid: ".$camid." Lastmodified alt: ".date('Y-m-d H:i:s', $cam[$camid]['LASTMODIFIED'])." Lastmodified neu: ".date('Y-m-d H:i:s', $array['LASTMODIFIED'][$n])." Zeile:".__LINE__);
                                    $cam[$camid]['LASTMODIFIED'] = $array['LASTMODIFIED'][$n];
                                    $cam[$camid]['IMSYSTEM'] = 0;
                                } else {
                                    // myecho("lastonline ".$camid);
                                }
                            } else {
                                $cam[$camid] = array();
                                // Existiert diese Datei im System?
                                if (file_exists($CONFIG['TEMPDIR'].$camid.".xml")) {
                                    // Dann laden um nachzusehen
                                    $this_cam = xml2array(implode("", file($CONFIG['TEMPDIR'].$camid.".xml")));
                                    if ($this_cam['LASTMODIFIED'] < $array['LASTMODIFIED'][$n]) {
                                        $cam[$camid]['LASTMODIFIED'] = $array['LASTMODIFIED'][$n];
                                        $cam[$camid]['IMSYSTEM'] = 0;
                                        $cam[$camid]['SHOWDETAILS'] = $array['SHOWDETAILS'][$n];
                                        $cam[$camid]['LASTONLINE'] = time();
                                    } else {
                                        $cam[$camid]['LASTMODIFIED'] = $array['LASTMODIFIED'][$n];
                                        $cam[$camid]['IMSYSTEM'] = 1;
                                        $cam[$camid]['SHOWDETAILS'] = $array['SHOWDETAILS'][$n];
                                        $cam[$camid]['LASTONLINE'] = time();
                                    }
                                    unset($this_cam);
                                } else {
                                    // Nein
                                    // die XML-Datei holen und speichern
                                    if (is_valid_XML_file($camid)) {
                                        $cam[$camid]['LASTMODIFIED'] = $array['LASTMODIFIED'][$n];
                                        $cam[$camid]['IMSYSTEM'] = 0;
                                        $cam[$camid]['SHOWDETAILS'] = $array['SHOWDETAILS'][$n];
                                        $cam[$camid]['LASTONLINE'] = time();
                                    }
                                }
                            }
                        }
                        test_kat($array, 0);
                        test_neu($array, $cam);
                    }
                } else {
                    if (is_array($array) && $save_category_file) {
                        // Nur abspeichern.
                        if (isset($array['ID'])) {
                            saveanzahl(count($array['ID']), $catid);
                        }
                        test_kat($array, $catid);
                        if ($save_category_file) {
                            $file = "kategorie-".$catid.".xml";
                            if (!savefile($file, "TEMPDIR", $dateibuffer)) {
                                die("Datei konnte nicht gespeichert werden, bitte prüfen Sie die Verzeichnisrechte von ".$CONFIG["TEMP"]);
                            }
                            $file = "kategorie-".$catid.".s";
                            if (!savefile($file, "TEMPDIR", serialize($array))) {
                                die("Datei konnte nicht gespeichert werden, bitte prüfen Sie die Verzeichnisrechte von ".$CONFIG["TEMP"]);
                            }
                        }
                        unset($array);
                    }
                }
                if (!$save_category_file) {
                    // myecho("categories.xml und categories.s wurden nicht gespeichert");
                }
                unset($dateibuffer);
            }
            $file = "cam.s";
            if (!savefile($file, "TEMPDIR", serialize($cam))) {
                die("Datei konnte nicht gespeichert werden, bitte pruefen Sie die Verzeichnisrechte von ".$CONFIG["TEMP"]);
            }
            // timestamp fetch speichern
            file_put_contents($timestamp_fetch_file, time());
            @chmod($timestamp_fetch_file, 0666);
            $get_cams = 0;
            foreach ($cam as $camid=>$werte) {
                // Wenn noch nicht im System, dann holen
                if ($werte['IMSYSTEM'] == 0) {
                    $nichts = get_cam_data($camid, 0, $werte['SHOWDETAILS']);
                    $cam[$camid]['IMSYSTEM'] = 1;
                    $cam[$camid]['LASTONLINE'] = time();
                    if (isset($disabled[$camid])) {
                        unset($disabled[$camid]);
                    }
                    $get_cams++;
                    if ($get_cams > $CONFIG['MAXFETCH']) {
                        break;
                    }
                }
            }
            $file = "cam.s";
            if (!savefile($file, "TEMPDIR", serialize($cam))) {
                die("Datei konnte nicht gespeichert werden, bitte prüfen Sie die Verzeichnisrechte von ".$CONFIG["TEMP"]);
            }
            $file = "disabled.s";
            if (!savefile($file, "TEMPDIR", serialize($disabled))) {
                die("Datei konnte nicht gespeichert werden, bitte prüfen Sie die Verzeichnisrechte von ".$CONFIG["TEMP"]);
            }
            if (function_exists("memory_get_usage")) {
                savelog("Speicher: ".memory_get_usage()." Bytes vor unset \$cam  Zeile:".__LINE__);
            }
            savelog("Anzahl Cams ".count($cam));
            unset($cam);
            if ($set_kategorie == 1) {
                $content_count_cams_file = '';
                for ($n = 0; $n < count($kategorie); $n++) {
                    if (!isset($kategorie[$n]['bezeichnung']) || $kategorie[$n]['bezeichnung'] == "") {
                        // nothing to do
                        $anzahl[$n] = 0;
                        $content_count_cams_file .= $anzahl[$n]."\n";
                    } else {
                        $xml_file = $CONFIG['TEMPDIR']."kategorie-".$n.".xml";
                        if (is_file($xml_file)) {
                            // myecho($xml_file);flush();
                            $objXML = new xmlutility();
                            $objXML->parse(file_get_contents($xml_file));
                            $anzahl[$n] = $objXML->getCountChildren();
                            if ($anzahl[$n] > 0 && $objXML->shuffleArray2Xml()) {
                                // myecho($xml_file);flush();
                                $xml_string = $objXML->getXMLString();
                                file_put_contents($xml_file, $xml_string);
                                $array = xml2array($xml_string);
                                $file = "kategorie-".$n.".s";
                                // myecho($array);flush();
                                if (!savefile($file, "TEMPDIR", serialize($array))) {
                                    die("Datei konnte nicht gespeichert werden, bitte prüfen Sie die Verzeichnisrechte von ".$CONFIG["TEMP"]);
                                }
                                $file = $CONFIG['TEMPDIR']."kategorie-".$n.".s";
                                $ergebnis = extend_kat(unserialize(implode("", file($file))));
                                // myecho('ergebnis: '.$ergebnis);
                                // die();
                                savefile("kategorie-".$n.".s", "TEMPDIR", serialize($ergebnis));
                            }
                        } else {
                            $anzahl[$n] = 0;
                        }
                        $content_count_cams_file .= $anzahl[$n]."\n";
                    }
                    $count_cams_file = $CONFIG['TEMPDIR']."anzahl.lst";
                    file_put_contents($count_cams_file, $content_count_cams_file);
                }
            }
        }
        getFavorites();
        return true;
    }
}


if (!function_exists('test_kat')) {
    function test_kat($array, $catid) {
        global $CONFIG;
        $CONFIG['MAXENTRYS'] = 50;
        if (isset($array['ID']) && !is_array($array['ID'])) {
            // myecho($catid.': '.$array['ID']);
            return false;
        }
        // Hier wird nur geprüft, ob
        // a. es schon 50 Eintraege in dieser Kategorie gibt
        // b. diese Cams schon drin sind.
        $file = "liste-".$catid.".s";
        if (file_exists($CONFIG['TEMPDIR'].$file)) {
            $liste = unserialize(implode("", file($CONFIG['TEMPDIR'].$file)));
        } else {
            $liste = array();
        }
        // Schmeisse alle aus der Liste, die nicht mehr existieren:
        $liste_neu = array();
        $save = 0;
        if (count($liste) > 0) {
            for ($n = 0; $n < count($liste); $n++) {
                $xml_datei = $CONFIG['TEMPDIR'].$liste[$n].".xml";
                if (file_exists($xml_datei)) {
                    $liste_neu[] = $liste[$n];
                } else {
                    $save = 1;
                }
            }
        }
        $liste = $liste_neu;
        if (count($liste) < $CONFIG['MAXENTRYS']) {
            if (isset($array['ID'])) {
                for ($n = 0; $n < count($array['ID']); $n++) {
                    if (!in_array($array['ID'][$n], $liste)) {
                        $liste[count($liste)] = $array['ID'][$n];
                        $save = 1;
                    }
                }
            }
        }
        
        if ($save == 1) {
            savefile($file, "TEMPDIR", serialize($liste));
        }
        unset($liste);
        unset($array);
        return true;
    }
}

if (!function_exists('test_neu')) {
    function test_neu($array, $cam) {
        global $CONFIG;
        $file = "neuliste.s";
        if (file_exists($CONFIG['TEMPDIR'].$file)) {
            $liste = unserialize(implode("", file($CONFIG['TEMPDIR'].$file)));
        } else {
            $liste = array();
        }
        for ($n = 0; $n < count($array['ID']); $n++) {
            if (!in_array($array['ID'][$n], $liste) && $cam[$array['ID'][$n]]['IMSYSTEM'] == 1) {
                $save = 1;
                $liste[count($liste)] = $array['ID'][$n];
            }
        }
        if (isset($save) && $save == 1) {
            savefile($file, "TEMPDIR", serialize($liste));
        }
        unset($liste);
        unset($array);
        return true;
    }
}
if (!function_exists('get_cam_data')) {
    function get_cam_data($sid, $woher = 0, $url = "") {
        global $CONFIG;
        // woher kann zwei Werte haben:
        // 0 = sollte im System sein
        // 1 = hole es vom Liveserver
        // Ah, es gibt eine Cam, hole deren Daten
        if ($sid < 1) {
            return false;
        }
        $sender = array();
        $xml_file_name = $sid.".xml";
        $xml_datei = $CONFIG['TEMPDIR'].$xml_file_name;
        
        $save = 0;
        $disabled = array();
        if (file_exists($CONFIG['TEMPDIR']."disabled.s")) {
            $disabled = unserialize(implode("", file($CONFIG['TEMPDIR']."disabled.s")));
        }
        if (isset($disabled[$sid])) {
            return false;
        }
        
        // Es kann natürlich sein, dass der/die Sender nicht online ist
        // also sieh einmal nach, ob die Daten nicht im temporaeren Ordner sind.
        if ($woher == 1 && file_exists($xml_datei)) {
            $dateibuffer = implode("\n", file($xml_datei));
            $sender = xml2array($dateibuffer);
        } else {
            // Wenn die ID nicht in der disabled-Datei ist sedcard holen und auf disabled pruefen
            if (!isset($disabled[$sid])) {
                $url = 'http://mm.777-partner.net/showdetail.php?show='.$sid.'&lang='.$CONFIG['LANGUAGE'];
                $url .= '&size=l&affiliateid='.$CONFIG["WMID"].'&version='.$CONFIG['VERSION'];
                $url .= '&host='.urlencode($_SERVER['HTTP_HOST']).'&build='.$CONFIG['BUILD'];
                $dateibuffer = get_content($url);
                // myecho($dateibuffer);
                if ($dateibuffer == "") {
                    $sender = false;
                } else {
                    $sender = xml2array($dateibuffer);
                    if (!isset($sender['DISABLED']) || $sender['DISABLED'] == 1) {
                        $disabled[$sid] = 1;
                        $file = "disabled.s";
                        savefile($file, "TEMPDIR", serialize($disabled));
                        // Benoetige die Bilder aus der Sedcard
                        // Loesche Bilder, wenn vorhanden (egal wie Einstellungen sind)
                        if (key_exists('PREVIEW', $sender)) {
                            if (!is_array($sender['PREVIEW'])) {
                                $picid = image_id($sender['PREVIEW']);
                                deletePreviewPicByPicId($picid);
                            } else {
                                foreach ($sender['PREVIEW'] as $key=>$value) {
                                    $picid = image_id($value);
                                    deletePreviewPicByPicId($picid);
                                }
                            }
                        }
                        $sender = false;
                    } else {
                        savefile($xml_file_name, "TEMPDIR", $dateibuffer);
                    }
                }
                if (!$sender && is_file($xml_datei)) {
                    $dateibuffer = implode("\n", file($xml_datei));
                    $data = xml2array($dateibuffer);
                    if (key_exists('PREVIEW', $data)) {
                        if (!is_array($sender['PREVIEW'])) {
                            $picid = image_id($data['PREVIEW']);
                            if (deletePreviewPicByPicId($picid)) {
                                savelog("Bild und Thumbs geloescht von Camid: ".$id." / Bildid: ".$picid);
                            }
                        } else {
                            foreach ($data['PREVIEW'] as $key=>$value) {
                                $picid = image_id($value);
                                if (deletePreviewPicByPicId($picid)) {
                                    savelog("Bild und Thumbs geloescht von Camid: ".$id." / Bildid: ".$picid);
                                }
                            }
                        }
                    }
                    @unlink($xml_datei);
                    savelog("XML-Datei geloescht von Camid: ".$sid);
                }
            }
        }
        return $sender;
    }
}

if (!function_exists('catchvar')) {
    function catchvar($var) {
        global $CONFIG;
        ob_start();
        var_dump($var);
        $inhalt = ob_get_contents();
        ob_end_clean();
        if ($fp = fopen($CONFIG['TEMPDIR']."log_var.txt", "a")) {
            fputs($fp, "------------------------------------------------------------------------");
            fputs($fp, date("H:i:s d.m.Y")." - ".__FILE__." - Variable: ".$var." \n");
            fputs($fp, "---");
            fputs($fp, $inhalt."\n");
            fclose($fp);
            chmod($CONFIG['TEMPDIR']."log_var.txt", 0666);
        }
    }
}

if (!function_exists('delete_old_files')) {
    function delete_old_files() {
        global $CONFIG,$system;
        // Hole zuerst die datum.lst um nachzusehen, ob es Zeit ist, zu loeschen
        $olddatum = $system['lastdelete'];
        // myecho(date('d.m.Y G:i:s',mktime(0, 0, 0, date("m"), date("d"), date("Y"))));
        // myecho(date('d.m.Y G:i:s', $olddatum));
        if ($olddatum < mktime(0, 0, 0, date("m"), date("d"), date("Y"))) {
            $camdata = array();
            $picdata = array();
            $system['lastdelete'] = time();
            savesystem();
            // Also durchsuche temp-Verzeichnis und wenn exisitert das images-Verzeichnis und das Cache-Verzeichnis
            $dateien = array();
            $dateien = @scandirneu($CONFIG['TEMPDIR']);
            // Nur die $dateien, die noch keinen lastonline-Stempel haben
            // echo $CONFIG['TEMPDIR']."cam.s";
            if (file_exists($CONFIG['TEMPDIR']."cam.s")) {
                $cam = unserialize(implode("", file($CONFIG['TEMPDIR']."cam.s")));
                // echo "Cams1: ";
                // print_r($cam);
            }
            // echo count($dateien);
            // print_r($dateien);
            foreach ($dateien as $key=>$value) {
                // Wenn $value in $cam ist, dann loesche sie aus $dateien, diese
                // Cams bekommen eine Sonderbehandlung
                $id = substr($value, 0, -4);
                if (is_numeric($id)) {
                    if (isset($cam[$id]['LASTONLINE'])) {
                        // neue Cam, aus alter Liste loeschen
                        unset($dateien[$key]);
                    }
                }
            }
            // echo count($dateien);
            // print_r($dateien);
            // exit;
            foreach ($dateien as $datei) {
                if (isset($CONFIG['DAYLIVINGCAM'])) {
                    if (is_file($CONFIG['TEMPDIR'].$datei) && (time() - filemtime($CONFIG['TEMPDIR'].$datei) > ($CONFIG['DAYLIVINGCAM'] * 24 * 60 * 60))) {
                        // $dateien[$n] im TEMPDIR darf nur eine Cam sein, also hinten .xml und vorne eine Zahl!
                        $endung = substr($datei, -4);
                        $vorne = substr($datei, 0, -4);
                        if ($endung == ".xml" && is_numeric($vorne)) {
                            @unlink($CONFIG['TEMPDIR'].$dateien[$n]);
                        }
                    }
                }
                
            }
            
            /** 
             * alles was aelter ist, wird geloescht
             *
             * Folgende Daten müssen dann geloescht werden:
             * - die sedcard
             * - die Bilder
             * - die cache-Datei
             * - die Eintraege in der sucheliste
             * - die Eintraege in der urllist.txt
             */
            // echo "Cams2: ";
            // print_r($cam);
            if (count($cam) > 0) {
                foreach ($cam as $key=>$value) {
                    // print_r($value);
                    if (isset($CONFIG['DAYLIVINGCAM'])) {
                        if (isset($value['LASTONLINE']) && $value['LASTONLINE'] < time() - ($CONFIG['DAYLIVINGCAM'] * 24 * 60 * 60)) {
                            // echo $key." wird geloescht.\n<br />";
                            cleanup($key);
                            unset($cam[$key]);
                        }
                    }
                }
            }
            // Speichere auch die cam
            $file = "cam.s";
            if (!savefile($file, "TEMPDIR", serialize($cam))) {
                die("Datei konnte nicht gespeichert werden, bitte prüfen Sie die Verzeichnisrechte von ".$CONFIG["TEMP"]);
            }
            
            resetcam();
            return true;
        }
    }
}

function savesystem() {
    global $CONFIG,$system;
    savefile("system.s", "TEMPDIR", serialize($system));
}

function setze_faktor() {
    global $CONFIG,$system;
    if ($CONFIG['TEXTE'] < 1) {
        return true;
    }
    if ($system['faktortime'] < time()) {
        $system['faktortime'] = 60 * 60 * $CONFIG['TEXTE'] * (1 + intval(time() / (60 * 60 * $CONFIG['TEXTE'])));
        $system['faktor'] = mt_rand(3, 100000);
        $prim = 0;
        while ($prim == 0) {
            $system['faktor']++;
            $prim = 1;
            for ($i = 2; $i < sqrt($system['faktor']); $i++) {
                if (($system['faktor'] % $i) == 0) {
                    $prim = 0;
                    break;
                }
            }
        }
        savesystem();
    }
}


function info_mail() {
    global $CONFIG;
    // Soll überhaupt geprüft werden?
    if ($CONFIG['MAIL'] == "" || $CONFIG['DOMAIN'] == "") {
        return false;
    }
    $heute = mktime(0, 0, 0, date("m"), date("d"), date("Y"));
    $morgen = mktime(0, 0, 0, date("m"), date("d") + 1, date("Y"));
    // Benoetige folgende Dateien:
    // update.lst -> wann wurde zuletzt auf die infourl zugegriffen?
    // mail.lst -> Wann wurde die letzte ID an den User gemailt?
    if (!file_exists($CONFIG['TEMPDIR']."update.lst")) {
        $fp = fopen($CONFIG['TEMPDIR']."update.lst", "w+");
        fputs($fp, $heute);
        fclose($fp);
        chmod($CONFIG['TEMPDIR']."update.lst", 0666);
        $fp = fopen($CONFIG['TEMPDIR']."mail.lst", "w+");
        fputs($fp, "");
        fclose($fp);
        chmod($CONFIG['TEMPDIR']."mail.lst", 0666);
    } else {
        $lastupdate = implode("", file($CONFIG['TEMPDIR']."update.lst"));
        if ($lastupdate < time()) {
            // Hole neues Update
            $fp = fopen($CONFIG['TEMPDIR']."update.lst", "w+");
            fputs($fp, $morgen);
            fclose($fp);
            
            $info = get_content($CONFIG['INFOURL']);
            $info = xml2array($info);
            if (count($info['ID']) == 1) {
                // wenn es nur einen Eintrag gibt
                // prüfe in mail.lst ob diese ID schon verschickt wurde
                if (test_mail_id($info['ID']) == false && ($info['STARTDATE'] == '0000-00-00' || date2time($info['STARTDATE']) < time()) && ($info['ENDDATE'] == '0000-00-00' || date2time($info['ENDDATE']) > time())) {
                    // Noch nicht verschickt, also verschicken.
                    if ($info['TYP'] == "info") {
                        $info['MAILSUBJECT'] = str_replace("{version}", $CONFIG['VERSION'], $info['MAILSUBJECT']);
                        $info['MAILTEXT'] = str_replace("{version}", $CONFIG['VERSION'], $info['MAILTEXT']);
                        @mail($CONFIG['MAIL'], $info['MAILSUBJECT'], $info['MAILTEXT'], "FROM: 777script@".$CONFIG['DOMAIN']." <noreply@".$CONFIG['DOMAIN'].">");
                    } else if ($info['TYP'] == "update") {
                        if ($info['VERSION'] != $CONFIG['VERSION']) {
                            $info['MAILSUBJECT'] = str_replace("{version}", $CONFIG['VERSION'], $info['MAILSUBJECT']);
                            $info['MAILTEXT'] = str_replace("{version}", $CONFIG['VERSION'], $info['MAILTEXT']);
                            @mail($CONFIG['MAIL'], $info['MAILSUBJECT'], $info['MAILTEXT'], "FROM: 777script@".$CONFIG['DOMAIN']." <noreply@".$CONFIG['DOMAIN'].">");
                        }
                    }
                    $fp = fopen($CONFIG['TEMPDIR']."mail.lst", "a");
                    fputs($fp, $info['ID']."=".date("d.m.Y")."\n");
                    fclose($fp);
                }
            } else if (count($info['ID']) > 1) {
                for ($n = 0; $n < count($info['ID']); $n++) {
                    // prüfe in mail.lst ob diese ID schon verschickt wurde
                    if (!test_mail_id($info['ID'][$n]) == false && ($info['STARTDATE'][$n] == '0000-00-00' || date2time($info['STARTDATE'][$n]) < time()) && ($info['ENDDATE'][$n] == '0000-00-00' || date2time($info['ENDDATE'][$n]) > time())) {
                        // Noch nicht verschickt, also verschicken.
                        if ($info['TYP'][$n] == "info") {
                            $info['MAILSUBJECT'][$n] = str_replace("{version}", $CONFIG['VERSION'], $info['MAILSUBJECT'][$n]);
                            $info['MAILTEXT'][$n] = str_replace("{version}", $CONFIG['VERSION'], $info['MAILTEXT'][$n]);
                            @mail($CONFIG['MAIL'], $info['MAILSUBJECT'][$n], $info['MAILTEXT'][$n], "FROM: 777script@".$CONFIG['DOMAIN']." <noreply@".$CONFIG['DOMAIN'].">");
                        } else if ($info['TYP'] == "update") {
                            if ($info['VERSION'] != $CONFIG['VERSION']) {
                                $info['MAILSUBJECT'] = str_replace("{version}", $CONFIG['VERSION'], $info['MAILSUBJECT']);
                                $info['MAILTEXT'] = str_replace("{version}", $CONFIG['VERSION'], $info['MAILTEXT']);
                                @mail($CONFIG['MAIL'], $info['MAILSUBJECT'], $info['MAILTEXT'], "FROM: 777script@".$CONFIG['DOMAIN']." <noreply@".$CONFIG['DOMAIN'].">");
                            }
                        }
                        $fp = fopen($CONFIG['TEMPDIR']."mail.lst", "a");
                        fputs($fp, $info['ID'][$n]."=".date("d.m.Y")."\n");
                        fclose($fp);
                    }
                }
            }
        }
    }
    return true;
}


function test_mail_id($id) {
    global $CONFIG;
    $mails = file($CONFIG['TEMPDIR']."mail.lst");
    for ($n = 0; $n < count($mails); $n++) {
        if ($mails[$n] != "") {
            $werte = explode("=", $mails[$n]);
            $werte[0] = trim($werte[0]);
            $werte[1] = trim($werte[1]);
            if ($werte[0] == $id) {
                return true;
            }
        }
    }
    return false;
}


function resetcam() {
    global $CONFIG;
    $all_files = scandirneu($CONFIG['TEMPDIR']);
    $cam = get_cams($all_files);
    savefile("cam.s", "TEMPDIR", serialize($cam));
}


function updatecam() {
    global $CONFIG;
    $all_files = scandirneu($CONFIG['TEMPDIR']);
    $cam = get_cams($all_files);
    savefile("cam.s", "TEMPDIR", serialize($cam));
    // Suche nach den Listen und übernehme sie, aber nur die IDs daraus.
    reset($all_files);
    foreach ($all_files as $file) {
        // Es muss sich um ein xml-File handeln, der vorderer Teil muss numerisch sein:
        $endung = substr($file, -4);
        $vorne = substr($file, 0, -4);
        if ($endung == ".lst" && substr($vorne, 0, 5) == "liste") {
            // Brauche die Nummer:
            list($name, $nummer) = explode("-", $vorne);
            $cams = file($CONFIG['TEMPDIR'].$file);
            $liste = array();
            if (count($cams) > 0) {
                foreach ($cams as $zeile) {
                    $werte = explode("/-/", $zeile);
                    if ($werte[0] > 0) {
                        $liste[count($liste)] = $werte[0];
                    }
                }
            }
            savefile("liste-".$nummer.".s", "TEMPDIR", serialize($liste));
            @unlink($CONFIG["TEMPDIR"].$file);
        } elseif ($endung == ".lst" && substr($vorne, 0, 9) == "neueliste") {
            // Brauche die Nummer:
            $cams = file($CONFIG['TEMPDIR'].$file);
            $liste = array();
            if (count($cams) > 0) {
                foreach ($cams as $zeile) {
                    $werte = explode("/-/", $zeile);
                    if ($werte[0] > 0) {
                        $liste[count($liste)] = $werte[0];
                    }
                }
            }
            savefile("neuliste.s", "TEMPDIR", serialize($liste));
        }
    }
}


function get_cams($all_files) {
    global $CONFIG;
    $cam = array();
    if (file_exists($CONFIG['TEMPDIR']."cam.s")) {
        $cam = unserialize(implode("", file($CONFIG['TEMPDIR']."cam.s")));
    }
    
    foreach ($all_files as $file) {
        // Es muss sich um ein xml-File handeln, der vorderer Teil muss numerisch sein:
        $endung = substr($file, -4);
        $vorne = substr($file, 0, -4);
        if ($endung == ".xml" && is_numeric($vorne)) {
            // Ist eine Cam, lade diese
            if (!isset($cam[$vorne])) {
                $this_cam = get_cam_data($vorne, 1);
                $cam[$vorne] = array();
                $cam[$vorne]['LASTMODIFIED'] = $this_cam['LASTMODIFIED'];
                $cam[$vorne]['IMSYSTEM'] = 1;
            }
        }
    }
    return $cam;
}


function sort_language($array, $catid) {
    global $CONFIG;
    if ($CONFIG['LANGUAGESELECTION'] == "") {
        return $array;
    }
    // Welche Felder gibt es?
    $felder = array();
    foreach ($array as $key=>$value) {
        // benoetige nur den $key
        $felder[] = $key;
    }
    reset($array);
    $language = array();
    if (isset($array['CAMINFOLANG'])) {
        for ($n = 0; $n < count($array['CAMINFOLANG']); $n++) {
            $sprache = $array['CAMINFOLANG'][$n];
            if (isset($language[$sprache]) && !is_array($language[$sprache])) {
                $language[$sprache] = array();
            }
            $language[$sprache][] = $n;
        }
    } else {
        $language['de'][] = 'de';
    }
    $all = explode(",", $CONFIG['LANGUAGESELECTION']);
    $gesamt = array();
    foreach ($all as $sprache) {
        if (isset($language[$sprache]) && is_array($language[$sprache])) {
            foreach ($language[$sprache] as $nummer) {
                foreach ($felder as $feld) {
                    if (!isset($gesamt[$feld])) {
                        $gesamt[$feld] = array();
                    }
                    if (isset($array[$feld][$nummer])) {
                        if (isset($array['ID']) && $array['ID'] == 25353) {
                            myecho($array[$feld][$nummer]);
                        }
                        $gesamt[$feld][] = $array[$feld][$nummer];
                    } else {
                        if (isset($array['ID']) && $array['ID'] == 25353) {
                            myecho($array[$feld]);
                        }
                        $gesamt[$feld][] = 'de';
                    }
                }
            }
        }
    }
    return $gesamt;
}

function cleanup($id) {
    // myecho('cleanup('.$id.')');
    
    global $CONFIG,$CAMLINKZ;
    $cam = array();
    if (file_exists($CONFIG['TEMPDIR']."cam.s")) {
        $cam = unserialize(implode("", file($CONFIG['TEMPDIR']."cam.s")));
    }
    // Die Sedcard wird benoetigt.
    $sender = get_cam_data($id, 1);
    if ($sender !== false && is_array($sender) && count($sender) > 0) {
        // Benoetige die Bilder aus der Sedcard
        // Loesche Bilder, wenn vorhanden (egal wie Einstellungen sind)
        if (key_exists('PREVIEW', $sender)) {
            if (!is_array($sender['PREVIEW'])) {
                $picid = image_id($sender['PREVIEW']);
                if (deletePreviewPicByPicId($picid)) {
                    savelog("Bild und Thumbs geloescht von Camid: ".$id." / Bildid: ".$picid);
                }
            } else {
                foreach ($sender['PREVIEW'] as $key=>$value) {
                    $picid = image_id($value);
                    if (deletePreviewPicByPicId($picid)) {
                        savelog("Bild und Thumbs geloescht von Camid: ".$id." / Bildid: ".$picid);
                    }
                }
            }
        }
    }
    
    // Loesche Cachedatei, wenn vorhanden (egal wie Einstellungen sind)
    if (file_exists($CONFIG['CACHEDIR'].$id.".cache")) {
        savelog("Cache-Datei loeschen von Camid: ".$id);
        @unlink($CONFIG['CACHEDIR'].$id.".cache");
    }
    
    // Loesche die Sedcard
    if (file_exists($CONFIG['TEMPDIR'].$id.".xml")) {
        savelog("Sedcard loeschen von Camid: ".$id);
        @unlink($CONFIG['TEMPDIR'].$id.".xml");
    }
    
    // myecho('cam.s');
    // myecho($cam);
    // Loesche aus cam.s
    if (isset($cam[$id])) {
        unset($cam[$id]);
        $file = "cam.s";
        if (!savefile($file, "TEMPDIR", serialize($cam))) {
            die("Datei konnte nicht gespeichert werden, bitte pruefen Sie die Verzeichnisrechte von ".$CONFIG["TEMP"]);
        }
    }

    
    // Loesche aus neuliste.s
    $neuliste = array();
    if (file_exists($CONFIG['TEMPDIR']."neuliste.s")) {
        $altliste = unserialize(implode("", file($CONFIG['TEMPDIR']."neuliste.s")));
        $neuliste = array();
        for ($n = 0; $n < count($altliste); $n++) {
            if ($altliste[$n] != $id) {
                $neuliste[] = $altliste[$n];
            } else {
                savelog("Aus neuliste loeschen von Camid: ".$id);
            }
        }
        $file = "neuliste.s";
        if (!savefile($file, "TEMPDIR", serialize($neuliste))) {
            die("Datei konnte nicht gespeichert werden, bitte pruefen Sie die Verzeichnisrechte von ".$CONFIG["TEMP"]);
        }
    }
    // myecho('alte camlist:');
    // myecho($altliste);
    // myecho('neuliste.s');
    // myecho($neuliste);
    // Loesche aus urllist.txt
    // Doch nach was soll ich suchen?
    $camlinkpos = 0;
    for ($n = 0; $n < count($CAMLINKZ); $n++) {
        if (strpos(trim($CAMLINKZ[$n]), "{id}") !== false) {
            $camlinkpos = $n;
        }
    }
    $ausdruck = str_replace("{id}", $id, $CAMLINKZ[$camlinkpos]);
    $ausdruck = "/".$ausdruck;
    if ($n < count($CAMLINKZ) + 1) {
        $ausdruck = "/".$ausdruck."/";
    }
    $ausdruck = str_replace('//', '/', $ausdruck);
    // Lade nun die urllist.txt
    
    // myecho('CAMLINKZ');
    // myecho($CAMLINKZ);
    // myecho($ausdruck);

    
    if (file_exists($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-URLLIST'].".txt")) {
        $change = 0;
        $alteurllist = file($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-URLLIST'].".txt");
        // myecho($alteurllist);
        $neueurllist = array();
        for ($n = 0; $n < count($alteurllist); $n++) {
            if (strlen(trim($alteurllist[$n])) > 0) {
                if (strpos(trim($alteurllist[$n]), $ausdruck) !== false) {
                    $change = 1;
                    savelog("Aus urllist.txt loeschen von Camid: ".$id);
                } else {
                    $neueurllist[] = $alteurllist[$n];
                }
            } else {
                $change = 1;
            }
            
        }
        if ($change == 1) {
            // myecho($neueurllist);die();
            $neueurllist = implode("\n", $neueurllist);
            $fp = fopen($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-URLLIST'].".txt", "w");
            fputs($fp, $neueurllist);
            fclose($fp);
            @chmod($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-URLLIST'].".txt", 0666);
        }
    }
    // Das ganze mit der filelist.dir
    $file = $CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-TEMPFILE'];
    // myecho($file);
    if (file_exists($file)) {
        // myecho($file);
        $change = 0;
        $altefilelist = file($file);
        $neuefilelist = array();
        // myecho($altefilelist);
        for ($n = 0; $n < count($altefilelist); $n++) {
            if (strlen(trim($altefilelist[$n])) > 0) {
                if (strpos(trim($altefilelist[$n]), $ausdruck) !== false) {
                    // tue nichts
                    $change = 1;
                    savelog("Aus filelist.dir loeschen von Camid: ".$id);
                } else {
                    $neuefilelist[] = $altefilelist[$n];
                }
            } else {
                $change = 1;
            }
        }
        if ($change == 1) {
            $neuefilelist = implode("\n", $neuefilelist);
            $fp = fopen($file, "w");
            fputs($fp, $neuefilelist);
            fclose($fp);
            @chmod($file, 0666);
        }
    }
    // myecho('$neuefilelist');
    // myecho($neuefilelist);
    return true;
}

function replacexml($old, $new) {
    global $CONFIG;
    $dateien = @scandirneu($CONFIG['TEMPDIR']);
    if (count($dateien)) {
        for ($n = 0; $n < count($dateien); $n++) {
            if (is_file($CONFIG['TEMPDIR'].$dateien[$n])) {
                // $dateien[$n] im TEMPDIR darf nur eine Cam sein, also hinten .xml und vorne eine Zahl!
                $endung = substr($dateien[$n], -4);
                $vorne = substr($dateien[$n], 0, -4);
                if ($endung == ".xml" && is_numeric($vorne)) {
                    // Okay, ersetze nun alt durch neu
                    $content = file_get_contents($CONFIG['TEMPDIR'].$dateien[$n]);
                    $content = str_replace($old, $new, $content);
                    file_put_contents($CONFIG['TEMPDIR'].$dateien[$n], $content);
                }
            }
        }
    }
}

function replacemain($old, $new) {
    global $CONFIG;
    $main = $_SERVER["DOCUMENT_ROOT"].$CONFIG['LAYOUTPATH']."/main.php";
    $datei = file_get_contents($main);
    $dateineu = str_replace($old, $new, $datei);
    if ($datei != $dateineu) {
        // Aha, es gibt etwas zu ersetzen, wie sieht es mit dem speichern aus?
        if (is_writeable($main)) {
            file_put_contents($main, $dateineu);
            // myecho("main.php wurde geaendert.");
        } else {
            // myecho("main.php wurde nicht geaendert.");
        }
    } else {
        // myecho("Es gibt nichts zu aendern!");
    }
}

function cleanup_func() {
    global $CONFIG;
    // Soll überhaupt geprueft werden?
    // myecho('cleanup start');
    $cleanupdata = get_content($CONFIG['CLEANUPURL']);
    // myecho($cleanupdata);die();
    if ( empty($cleanupdata) && empty($CONFIG['CAMAUSSCHLUSS'])) {
        return false;
    }
    // myecho($cleanupdata);
    $file = "disabled.s";
    $disabled = array();
    if (file_exists($CONFIG['TEMPDIR'].$file)) {
        $disabled = unserialize(implode("", file($CONFIG['TEMPDIR'].$file)));
    }
    // myecho($disabled);
    if (! empty($cleanupdata)) {
        $cleanupdata = xml2array($cleanupdata);
        // myecho($cleanupdata);
        foreach ($cleanupdata['ID'] as $key=>$value) {
            $camid = $cleanupdata['ID'][$key];
            // myecho($camid);
            $disabled[$camid] = 'x';
        }
		if(count($disabled) > 0){
			foreach($disabled as $key => $value){
				// myecho($key);
				if (cleanup($key)) {
	                $disabled[$key] = 1;
	            }
			}
		}
    }
    // myecho($disabled);
    // die();
    // myecho('cam cleanup, now cleanup replace');
    
    $file2 = "replace.s";
    $replace = array();
    if (file_exists($CONFIG['TEMPDIR'].$file2)) {
        $replace = unserialize(implode("", file($CONFIG['TEMPDIR'].$file2)));
    }
    if (! empty($cleanupdata) && isset($cleanupdata['REPLACE'])) {
        // myecho($cleanupdata['REPLACE']);
        // myecho('replace');
        // myecho($replace);
        
        foreach ($cleanupdata['REPLACE'] as $key=>$value) {
            // $value muss erst noch getrennt werden
            list($old, $new) = explode("|", $value);
            $old = trim($old);
            $new = trim($new);
            if (isset($replace[$old][$new]) && $replace[$old][$new] != $new) {
                // myecho($old."  ".$new);
                replacexml($old, $new);
                replacemain($old, $new);
                $replace[$old][$new] = $new;
            }
        }
    }
    // myecho('nach replace');
    if (! empty($CONFIG['CAMAUSSCHLUSS'])) {
        $cleanupdata = explode(",", $CONFIG['CAMAUSSCHLUSS']);
        foreach ($cleanupdata as $value) {
            $value = trim($value);
            if (!isset($disabled[$value]) && is_numeric($value)) {
                cleanup($value);
                $disabled[$value] = 'x';
            }
        }
    }
    // myecho('nach cleanup');
    if (!savefile($file, "TEMPDIR", serialize($disabled))) {
        die("Datei konnte nicht gespeichert werden, bitte prüfen Sie die Verzeichnisrechte von ".$CONFIG["TEMP"]);
    }
    if (!savefile($file2, "TEMPDIR", serialize($replace))) {
        die("Datei konnte nicht gespeichert werden, bitte prüfen Sie die Verzeichnisrechte von ".$CONFIG["TEMP"]);
    }
    // myecho('vor deleteNominalMembers()');
    deleteNominalMembers();
    return true;
}

/**
 * Auch die Karteileichen müssen raus:
 * nicht verzeichnete xml-Dateien
 * nicht zu einer Sedcard gehoerenden
 * - Bilder
 * - Cache-Dateien
 * - Sucheeintraege
 * - Eintraege in der URL-Liste
 */
function deleteNominalMembers() {
    // myecho(" deleteNominalMembers();");
    global $CONFIG;
    $cam = array();
    if (file_exists($CONFIG['TEMPDIR']."cam.s")) {
        $cam = unserialize(implode("", file($CONFIG['TEMPDIR']."cam.s")));
    }
    // Hole alle Sedcards
    $sedcard = array();
    $temp_files = @scandirneu($CONFIG['TEMPDIR']);
    // myecho($dateien);
    if (count($temp_files) > 0) {
        for ($n = 0; $n < count($temp_files); $n++) {
            if (is_file($CONFIG['TEMPDIR'].$temp_files[$n])) {
                // $dateien[$n] im TEMPDIR darf nur eine Cam sein, also hinten .xml und vorne eine Zahl!
                $endung = substr($temp_files[$n], -4);
                $vorne = substr($temp_files[$n], 0, -4);
                if ($endung == ".xml" && is_numeric($vorne)) {
                    $sedcard[] = $vorne;
                }
            }
        }
    }
    // myecho('nach XML-Dateien laden');
    // myecho($sedcard);
    // myecho($cam);
    if (count($sedcard) > 0) {
        $temp_dir = $CONFIG['TEMPDIR'];
        if (substr($temp_dir, strlen($temp_dir) - 1) != '/') {
            $temp_dir .= '/';
        }
        foreach ($sedcard as $key=>$value) {
            $xml_file_name = $value.'.xml';
            $xml_file = $temp_dir.$xml_file_name;
            // myecho($value);
            if (!isset($cam[$value])) {
                // myecho($value." loeschen");
                cleanup($value);
                // xml-datei loeschen wenn vorhanden
                if (is_file($xml_file)) {
                    @unlink($xml_file);
                }
            } else {
                if (isset($CONFIG['DAYLIVINGCAM'])) {
                    // vielleicht ist die Datei vergessen worden und schon gar nicht mehr gueltig
                    if (is_file($xml_file) && time() - filemtime($xml_file) > ((24 * 60 * 60) * $CONFIG['DAYLIVINGCAM'])) {
                        //@unlink($xml_file);
                    }
                }
            }
        }
    }
    // myecho('cleanup: $cam');
    // myecho('nach cleanup');
    // Umgekehrt gilt das aber auch.
    // Zu jedem $cam-Eintrag muss es eine Sedcard geben, ansonsten loeschen
    if (count($cam) > 0) {
        foreach ($cam as $camid=>$value) {
            if (!file_exists($CONFIG['TEMPDIR'].$camid.".xml")) {
                cleanup($camid);
                unset($cam[$camid]);
            }
        }
    }
    // myecho('nach cleanup: $cam');
    // myecho('vor Bilder loeschen');
    if (isset($CONFIG['DAYLIVINGCAM'])) {
        $images = @scandirneu($CONFIG['IMAGEDIR']);
        if (count($images) > 0) {
            for ($n = 0; $n < count($images); $n++) {
                $file = $CONFIG['IMAGEDIR'].$images[$n];
                if (is_file($file) && substr($file, strripos($file, '.') + 1) == 'jpg') {
                    $extansion = substr($file, strripos($file, '.') + 1);
                    
                    if (time() - filemtime($file) > ((60 * 60 * 24) * $CONFIG['DAYLIVINGCAM'])) {
                        @unlink($file);
                    }
                }
            }
        }
        // myecho('nach Bilder loeschen');
        // myecho('Thumbnails nach DAYLIVINGCAM oder 14 Tagen loeschen, was zuerst eintritt');
        $thumbnails_directory = $CONFIG['IMAGEDIR'].$CONFIG['THUMBSDIR'];
        if (!is_dir($thumbnails_directory)) {
            savelog($thumbnails_directory.' ist nicht vorhanden');
        } else {
            $thumbnails = @scandirneu($thumbnails_directory);
            $time_diff = (60 * 60 * 24) * $CONFIG['DAYLIVINGCAM'];
            if (count($thumbnails) > 0) {
                for ($n = 0; $n < count($thumbnails); $n++) {
                    $file = $thumbnails_directory.$thumbnails[$n];
                    if (is_file($file) && substr($file, strripos($file, '.') + 1) == 'jpg') {
                        $extansion = substr($file, strripos($file, '.') + 1);
                        if (time() - filemtime($file) > $time_diff) {
                            @unlink($file);
                        }
                    }
                }
            }
        }
    }
    // myecho('endeThumbnails loeschen');
    // Und das Cache-Verzeichnis
    // myecho('CACHE:');
    $files = @scandirneu($CONFIG['CACHEDIR']);
    // myecho('Cache_path:'. $CONFIG['CACHEDIR']);
    // myecho($dateien);
    if (count($files) > 0) {
        for ($n = 0; $n < count($files); $n++) {
            $file_name = $files[$n];
            $file = $CONFIG['CACHEDIR'].$file_name;
            if (strlen($file_name) > 6 && is_file($file) && strpos($file_name, '.cache') !== false && time() - filemtime($file) > 1200) {
                @unlink($file);
            }
        }
    }
    // Cam wieder speichern.
    $file = "cam.s";
    if (!savefile($file, "TEMPDIR", serialize($cam))) {
        die("Datei konnte nicht gespeichert werden, bitte prüfen Sie die Verzeichnisrechte von ".$CONFIG["TEMP"]);
    }
}
/**
 * zeigt ein kleines GIF an
 * @return boolean
 */
if (!function_exists('display_fetch_gif')) {
    function display_fetch_gif() {
        $gif = "R0lGODlhBQAFAJEAAAAAAP///////wAAACH5BAUUAAIALAAAAAAFAAUAAAIElI+pWAA7";
        if (!headers_sent()) {
            header("Content-type: image/gif");
        }
        echo base64_decode($gif);
        @flush();
        @ob_flush();
        return true;
    }
}

function getFavorites() {
    global $CONFIG;
    if ( empty($CONFIG['FAVORITEN'])) {
        return false;
    }
    $favorites = explode(",", $CONFIG['FAVORITEN']);
    $cam = array();
    if (file_exists($CONFIG['TEMPDIR']."cam.s")) {
        $cam = unserialize(implode("", file($CONFIG['TEMPDIR']."cam.s")));
    }
    if (count($favorites)) {
        $file = "disabled.s";
        $disabled = array();
        if (file_exists($CONFIG['TEMPDIR'].$file)) {
            $disabled = unserialize(implode("", file($CONFIG['TEMPDIR'].$file)));
        }
        
        foreach ($favorites as $key=>$camid) {
            $camid = trim($camid);
            // darf nicht in der disabled sein
            if (!isset($disabled[$camid])) {
                // Sedcard da?
                $file = $camid.".xml";
                if (!file_exists($CONFIG['TEMPDIR'].$file)) {
                    $sender = get_cam_data($camid, 0);
                    if (!isset($sender['SHOWDETAILS'])) {
                        $sender['SHOWDETAILS'] = "http://mm.777partner.net/showdetail.php?show={$camid}&size=l&lang=de";
                    }
                    $cam[$camid]['LASTMODIFIED'] = $sender['LASTMODIFIED'];
                    $cam[$camid]['IMSYSTEM'] = 1;
                    $cam[$camid]['SHOWDETAILS'] = $sender['SHOWDETAILS'];
                    $cam[$camid]['LASTONLINE'] = time();
                } elseif (isset($cam[$camid])) {
                    $cam[$camid]['LASTONLINE'] = time();
                } else {
                    $sender = get_cam_data($camid, 0);
                    if (!isset($sender['SHOWDETAILS'])) {
                        $sender['SHOWDETAILS'] = "http://mm.777partner.net/showdetail.php?show={$camid}&size=l&lang=de";
                    }
                    $cam[$camid]['LASTMODIFIED'] = $sender['LASTMODIFIED'];
                    $cam[$camid]['IMSYSTEM'] = 1;
                    $cam[$camid]['SHOWDETAILS'] = $sender['SHOWDETAILS'];
                    $cam[$camid]['LASTONLINE'] = time();
                }
            }
        }
    }
    // Cam wieder speichern.
    $file = "cam.s";
    if (!savefile($file, "TEMPDIR", serialize($cam))) {
        die("Datei konnte nicht gespeichert werden, bitte prüfen Sie die Verzeichnisrechte von ".$CONFIG["TEMP"]);
    }
}

?>
