<?php 
if (!class_exists('fillupcollection')) {
    class fillupcollection extends utilities {
    
        public $s_files = null;
        private $filled = false;
        private $category_id = null;
        private $categories_ids_to_fillup = null;
        private $file_pattern = 'liste';
        private $webmaster_category_ids = null;
        private $temp_directory = null;
        
        private $enabledshows_xml_file = null;
        private $liste_s_file = null;
        private $remote = null;
        private $remote_file_name = 'enabledshows.xml.php';
        private $remote_directory = '_xml/enabledshows/';
        private $remote_file = null;
        private $remote_query = null;
        private $limit = null;
        
        private $fillup_files = null;
        private $enabled_shows_ids = null;
        
        public function __construct() {
            // myecho(__CLASS__);
            self::setRemoteFile();
            self::setLimit();
            self::setTempDirectory();
            self::setWebmasterCategoryIds();
            // self::loadSFiles();
            self::readSFiles();
            self::setfillup_files();
            self::fill();
        }
        
        private function setLimit() {
            global $CONFIG;
            $this->limit = $CONFIG['COLS'] * $CONFIG['ROWS'];
        }
        
        private function setRemoteFile() {
            $this->remote = 'http://mm.777-partner.net/';
            $this->remote_file = $this->remote.$this->remote_directory.$this->remote_file_name;
            
        }
        
        public function setTempDirectory() {
            global $CONFIG;
            $this->temp_directory = parent::getDocRoot().$CONFIG['TEMPDIR'];
            if (substr($this->temp_directory, strlen($this->temp_directory) - 1) !== '/') {
                $this->temp_directory .= '/';
            }
        }
        
        public function setWebmasterCategoryIds() {
            global $kategorie;
            $i = 0;
            foreach ($kategorie as $k) {
                if (is_array($k) && count($k) > 0) {
                    if (is_null($this->webmaster_category_ids)) {
                        $this->webmaster_category_ids = array();
                    }
                    $this->webmaster_category_ids[] = $i;
                }
                $i++;
            }
            //myecho($this->webmaster_category_ids);
        }
        
        public function loadSFiles() {
            global $CONFIG;
            // myecho($temp_directory);
            $files = scandirneu($this->temp_directory);
            // myecho($files);
            if (count($files) > 0) {
                $this->s_files = array();
            }
            foreach ($files as $file) {
                if (substr($file, strripos($file, '.') + 1) == 's' && strpos($file, $this->file_pattern) !== false) {
                    $this->s_files[] = $temp_directory.$file;
                }
            }
        }
        
        public function readSFiles() {
            global $CONFIG;
            foreach ($this->webmaster_category_ids as $webmaster_category_id) {
                $webmaster_category_id = (int) $webmaster_category_id;
                // myecho($webmaster_category_id);
                $webmaster_category = false;
                switch ($webmaster_category_id) {
                    case 12:
                    case 19:
                        break;
                    default:
                        $webmaster_category = true;
                }
                if ($webmaster_category) {
                    $s_file = $this->temp_directory."{$this->file_pattern}-{$webmaster_category_id}.s";
                    $this->s_files[] = $s_file;
                    if (is_file($s_file)) {
                        $array = unserialize(implode("", file($s_file)));
                        $count = 0;
                        // myecho($array);
                        $count = count($array);
                        if ($count < $this->limit) {
                            // myecho($s_file);
                            // myecho($count);
                            self::setCategoryId($s_file);
                            // myecho('In der kategorie ('.$this->category_id.') sind '.$count.' gespeichert');
                            $this->categories_ids_to_fillup[] = $webmaster_category_id;
                        }
                    } else {
                        // myecho('In der kategorie ('.$webmaster_category_id.') sind keine daten gespeichert');
                        $this->categories_ids_to_fillup[] = $webmaster_category_id;
                    }
                }
            }
        }
        
        private function setCategoryId($s_file) {
            $part = substr($s_file, strripos($s_file, '/'));
            $part = substr($part, strpos($part, '-') + 1);
            $this->category_id = substr($part, 0, strpos($part, '.'));
            // myecho($this->category_id);
            if (!is_numeric($this->category_id) || $this->category_id < 0) {
                throw new Exception($this->category_id.' ist keine gueltige KategorieId');
            }
        }
        
        public function setfillup_files() {
            global $CONFIG;
            if (!is_null($this->categories_ids_to_fillup) && count($this->categories_ids_to_fillup) > 0) {
                // myecho($this->categories_ids_to_fillup);
                foreach ($this->categories_ids_to_fillup as $category_id) {
                    if ($category_id == 0) {
                        $this->enabledshows_xml_file = $this->temp_directory.'enabledshows.xml';
                    } else {
                        $this->enabledshows_xml_file = $this->temp_directory.'enabledshows_category_'.$category_id.'.xml';
                    }
                    $this->liste_s_file = $this->temp_directory.'liste-'.$category_id.'.s';
                    $this->remote_query = '?category_id='.$category_id;
                    if (is_null($this->fillup_files)) {
                        $this->fillup_files = array();
                    }
                    $this->fillup_files[] = new fillupfiles($this->remote_file.$this->remote_query, $this->enabledshows_xml_file, $this->liste_s_file);
                }
            }
        }
        
        public function fill() {
            if (!is_null($this->fillup_files) && count($this->fillup_files) > 0) {
                foreach ($this->fillup_files as $fillup) {
                    // myecho($fillup);
                    if (!is_file($fillup->category_xml_file) || time() - filemtime($fillup->category_xml_file) > (60 * 60 * 24)) {
                        // myecho($fillup->category_xml_file.' muss erstellt werden');
                        self::createXMLFile($fillup);
                    }
                    self::loadEnabledShowIds($fillup);
                    self::createSFile($fillup->liste_s_file);
                }
            }
            if ($this->filled) {
                // cam.s und andere loeschen
                self::deleteSystemFiles();
            }
        }
        
        private function deleteSystemFiles() {
            $file_names = array('system.s', 'cam.s', 'timestamp_fetch.txt', 'update.lst', 'install_check.txt', 'timestamp_filelist.txt');
            foreach ($file_names as $file_name) {
                $file = $this->temp_directory.$file_name;
                if (is_file($file)) {
                    if (!@unlink($file)) {
                        throw new Exception($file.' konnte nicht geloescht werden');
                    }
                }
            }
        }
        
        private function createSFile($file) {
            if (count($this->enabled_shows_ids) > 0) {
                if (is_file($file)) {
                    if (!@unlink($file)) {
                        throw new Exception($file.' konnte nicht geloescht werden');
                    }
                }
                $content = serialize($this->enabled_shows_ids);
                // myecho($file. ': '. $content);
                if (!@file_put_contents($file, $content)) {
                    throw new Exception($file.' konnte nicht erstellt werden');
                }
                $this->filled = true;
            }
        }
        
        private function loadEnabledShowIds($fillup) {
            global $CONFIG;
            $images_config_directory = $CONFIG['IMAGEDIR'];
            $directory = parent::getDocRoot();
            $script_directory = utilities::getScriptDirectory(__FILE__, '_classes/');
            $directory .= $script_directory;
            $directory = str_ireplace('//', '/', $directory);
            $CONFIG['IMAGEDIR'] = $directory.$CONFIG['IMAGEDIR'];
            // myecho($CONFIG['IMAGEDIR']);
            if (!is_dir($CONFIG['IMAGEDIR'])) {
            	$error = __METHOD__. ' : '. $CONFIG['IMAGEDIR'].' ist nicht vorhanden';
                throw new Exception($error);
            }
            $this->enabled_shows_ids = array();
            if($xml = @simplexml_load_file($fillup->category_xml_file)){
				if(count($xml) > 0){
					$i = 0;
            // myecho('Anzahl shows in: '.$fillup->category_xml_file. ' ('.count($xml).')');
			
            foreach ($xml as $show) {
                $log_text = null;
                $valid = true;
                $camid = (int) $show->camid;
                $show_xml_file = $this->temp_directory.$camid.'.xml';
                // myecho($show_xml_file);
                if (!is_file($show_xml_file) || time() - filemtime($show_xml_file) > 1200) {
                    $remote_showtail_xml = $this->remote.'showdetail.php?show='.$camid.'&lang='.$CONFIG['LANGUAGE'].'&size=l';
                    // echolink($remote_showtail_xml);
                    $content = get_content($remote_showtail_xml);
                    if (strlen($content) > 0) {
                        // myecho($conent);die();
                        // Wenn Daten kommen, dann wegen language sortieren.
                        $array = xml2array($content);
                        // myecho($array);
                        // Pruefen, ob alles okay ist.
                        if (isset($array['INFO']) && $array['INFO'] != "") {
                            $log_text = "Result: ".$array['RESULT']."\n<br />Info: ".$array['INFO'];
                        }
                    } else {
                        $log_text = "Es kommen keine Daten vom 777live-Server.";
                    }
                    if (!is_null($log_text)) {
                        savelog($log_text);
                        $valid = false;
                    }
                    if ($valid) {
                        if (is_file($show_xml_file)) {
                            @unlink($show_xml_file);
                        }
                        // myecho($show_xml_file. ' wurde gespeichert');
                        file_put_contents($show_xml_file, $content);
                    }
                } else {
                    $content = file_get_contents($show_xml_file);
                }
                if ($valid) {
                    // Bilder muessen gespeichert werden
                    self::savePreviewPics($content);
                    // myecho('Bilder wurden ueberprueft bzw. gespeichert');
                    $this->enabled_shows_ids[] = $camid;
                    $i++;
                    if ($i == $this->limit) {
                        break;
                    }
                }
            }
            if (isset($xml)) {
                unset($xml);
            }
				}
			}
            
            $CONFIG['IMAGEDIR'] = $images_config_directory;
        }
        
        public static function savePreviewPics($content) {
            global $CONFIG;
            if ($CONFIG['SAVEIMAGES'] == 1) {
                $xml = simplexml_load_string($content);
                $array_previewurl = array();
                foreach ($xml->previewpics->preview as $preview) {
                    $array_previewurl[] = (string) $preview;
                }
                // myecho($array_previewurl);
                unset($xml);
                if (!save_preview_images($array_previewurl)) {
                    $message = __METHOD__.' - Bilder konnten nicht gespeichert werden';
                    myecho($message);
                    throw new Exception($message);
                }
            }
        }
        
        private function createXMLFile($fillup_files) {
            // myecho($fillup_files->remote_file);
            $content = get_content($fillup_files->remote_file);
            // myecho($content);
            if (is_file($fillup_files->category_xml_file)) {
                @unlink($fillup_files->category_xml_file);
            }
            file_put_contents($fillup_files->category_xml_file, $content);
        }
        
        public function getFilled() {
            return $this->filled;
        }
        
    }

    
}
?>
