<?php

if (!class_exists('xmlutility')) {
    class xmlutility {
    
        var $arrOutput = array();
        var $resParser;
        var $strXmlData;
        var $xml_string = '';
        var $count_children = 0;
        
        function parse($strInputXML) {
        
            $this->resParser = xml_parser_create();
            xml_set_object($this->resParser, $this);
            xml_set_element_handler($this->resParser, "tagOpen", "tagClosed");
            
            xml_set_character_data_handler($this->resParser, "tagData");
            
            $this->strXmlData = xml_parse($this->resParser, $strInputXML);
            if (!$this->strXmlData) {
                die(sprintf("XML error: %s at line %d", xml_error_string(xml_get_error_code($this->resParser)), xml_get_current_line_number($this->resParser)));
            }
            
            xml_parser_free($this->resParser);
            
            return $this->arrOutput;
        }
        function tagOpen($parser, $name, $attrs) {
            $tag = array("name"=>$name, "attrs"=>$attrs);
            array_push($this->arrOutput, $tag);
        }
        
        function tagData($parser, $tagData) {
            if (trim($tagData)) {
                if (isset($this->arrOutput[count($this->arrOutput) - 1]['tagData'])) {
                    $this->arrOutput[count($this->arrOutput) - 1]['tagData'] .= $tagData;
                } else {
                    $this->arrOutput[count($this->arrOutput) - 1]['tagData'] = $tagData;
                }
            }
        }
        
        function getCountChildren() {
            if (isset($this->arrOutput[0]['children']) && count($this->arrOutput[0]['children']) > 0) {
                $this->count_children = count($this->arrOutput[0]['children']);
            }
            return $this->count_children;
        }
        
        function tagClosed($parser, $name) {
            $this->arrOutput[count($this->arrOutput) - 2]['children'][] = $this->arrOutput[count($this->arrOutput) - 1];
            array_pop($this->arrOutput);
        }
        
        function shuffleArray2Xml() {
            $bResult = false;
            // myecho($this->arrOutput[0]['children']);
            if (isset($this->arrOutput[0]['children']) && count($this->arrOutput[0]['children']) > 0) {
                // myecho($arrOutput[0]['children']);
                shuffle($this->arrOutput[0]['children']);
                // myecho($this->arrOutput[0]['children']);
                $this->xml_string = '<?xml version="1.0" encoding="UTF-8" ?>
        	    				<camlist xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns="http://remote.777live.com/showservice.php">'."\n";
                foreach ($this->arrOutput[0]['children'] as $caminfo) {
                    $this->xml_string .= '<caminfo>'."\n";
                    foreach ($caminfo['children'] as $child) {
                        $nodeName = strtolower($child['name']);
                        $nodeValue = utilities::fixUTF8($child['tagData']);
                        if (!is_numeric($nodeValue) && ($nodeValue != 'true' || $nodeValue == 'false')) {
                            $this->xml_string .= '<'.$nodeName.'><![CDATA['.$nodeValue.']]></'.$nodeName.'>'."\n";
                        } else {
                            $this->xml_string .= '<'.$nodeName.'>'.$nodeValue.'</'.$nodeName.'>'."\n";
                        }
                        
                    }
                    $this->xml_string .= '</caminfo>'."\n";
                }
                $this->xml_string .= '</camlist>';
                $bResult = true;
            }
            return $bResult;
        }
        
        function getXMLString() {
            return $this->xml_string;
        }
    }
}
?>
