<?php 
/*****************************************************
 *                                                   *
 *  777Script Version 8.1                            *
 *  image.php V. 1.0                                 *
 *  Diese Datei sollte nicht veraendert werden.      *
 *                                                   *
 *****************************************************/

// Einbinden der Config. muss ggf. angepasst werden, wenn sich die
// config.inc.php woanders befindet oder einen anderen Namen hat.
require_once ("../config.inc.php");
require_once ("../_system/autoload.inc.php");
require_once ("../_system/scripthelper.inc.php");

if ($CONFIG['PATH'] == "/") {
    $CONFIG['PATH'] = "";
}

$url = $_SERVER["REQUEST_URI"];

// Reduziere die $url auf den Teil nach $CONFIG[PATH]
$url = substr($url, 1 + strlen($CONFIG['PATH']));
$bild_id = get_image_id($url);
// myecho($bild_id);

if ($bild_id < 0) {
    // Nimm die URL auseinander
    $url_teile = explode("/", $url);
    
    // Durchsuche alle Teile nach der ID
    for ($n = 0; $n < count($url_teile); $n++) {
        if ($bild_id == -1)
            $bild_id = test_bild($url_teile[$n], $n);
    }
}

if ($bild_id < 0) {
    $error = $url.' Keine BildId gefunden';
    savelog($error);
    die($error);
}
$sizes = get_image_sizes($url);
$width = $sizes['width'];
$height = $sizes['height'];
if($width >= 320 || $height >= 240){
	$width = 320;
	$height = 240;
}
if ($CONFIG['SAVEIMAGES'] == 1) {

    if ($width != 320 && $height != 240) {
        $thumbnails_directory = $CONFIG['THUMBSDIR'];
        if (!is_dir($thumbnails_directory)) {
            $error = $thumbnails_directory.' Bitte mit Schreibrechten (777 oder 755 je nach Servereinstellung) anlegen';
            savelog($error);
            die($error);
        }
        $image = $thumbnails_directory."{$bild_id}_{$width}x{$height}.jpg";
    } else {
        $image = "{$bild_id}.jpg";
    }    
    // myecho($image);
    // Wenn das Bild existiert:
    if (file_exists($image)) {
        if (substr($config_path, strlen($config_path)) !== '/') {
            $config_path .= '/';
        }
        //header("Location: {$config_path}{$image}", true, 307);
        //die();
        header("Content-Type: image/jpeg");
        header("HTTP/1.0 200 OK");
        header("Content-Transfer-Encoding: binary");
        echo(file_get_contents($image));
    } else {
        // nachsehen ob das Bild in Originalgroesse vorliegt
        $image_original = $bild_id.".jpg";
        if (!is_file($image_original)) {
            $remote_image = $bild_id."_320x240.jpg";
            // myecho($remote_image);
            $host = 'mm.777-partner.net';
            $loc = '/images/'.$remote_image;
            $remote = 'http://'.$host.$loc;
            // echolink($remote);
            // erst nachsehen ob das Bild auf remote vorhanden ist
            if (!utilities::head($host, $loc)) {
                $remote = 'http://'.$host.'/images/404picture.php?url=%2Fimages%2F'.$remote_image;
            }
			// echolink($remote);
            $picturedata = get_content($remote);
            if (strlen(trim($picturedata)) > 6 && strtoupper(bin2hex(substr($picturedata, 0, 6))) == "326232310D0A") {
                $picturedata = substr($picturedata, 6);
            }
            if (strlen(trim($picturedata)) == 0 || strtoupper(bin2hex(substr($picturedata, 0, 4))) != "FFD8FFE0" || strtoupper(bin2hex(substr($picturedata, 6, 4))) != "4A464946") {
                $error = $remote_image.' konnte nicht geholt werden';
                savelog($error);
                die($error);
            }
            $phandle = fopen($image_original, "w");
            if ($phandle) {
                fwrite($phandle, $picturedata);
                fclose($phandle);
            }
        }
        if ($width != 320 && $height != 240) {
            try {
                // Bild verkleinern und dann ausgeben
                $thumbnail_file = $image;
                $thumbnailcreator = new thumbnailcreator($image_original, '');
                $thumbnailcreator->readImage();
                $thumbnailcreator->createThumbnail($width, $height, $thumbnail_file);
                $thumbnailcreator->createHeader();
                echo(file_get_contents($thumbnail_file));
                if (isset($thumbnailcreator)) {
                    unset($thumbnailcreator);
                }
            }
            catch(exception $e) {
                $error = $e->getMessage();
                savelog($error);
                die($error);
            }
        } else {
            header("Content-Type: image/jpeg");
            header("HTTP/1.0 200 OK");
            header("Content-Transfer-Encoding: binary");
			if(isset($picturedata)){
				echo($picturedata);
			}else{
				echo(file_get_contents($image_original));
			}
        }
    }
} else {
    // Bild von mm.777partner anzeigen
	if($width <= 100){
		$remote_image = $bild_id."_100x75.jpg";
	}
    elseif ($width > 100 && $width <= 140) {
        $remote_image = $bild_id."_137x102.jpg";
    } else {
        $remote_image = $bild_id."_320x240.jpg";
    }
    $url = "http://mm.777-partners.net/images/404picture.php?url=%2Fimages%2F".$remote_image;
    header('Location: '.$url, true, 301);
}
exit();
?>