<?php 

if (!@set_time_limit(600)) {
    // die('time limit wurde nicht gesetzt');
}

ignore_user_abort(true);

require_once ("config.inc.php");

if ((key_exists('DEVELOPMENT', $_SESSION) && $_SESSION['DEVELOPMENT']) || (key_exists('debug', $_REQUEST) && $_REQUEST['debug'] == 1)) {
    @error_reporting(E_ALL | E_NOTICE | E_STRICT);
    @ini_set('display_errors', '1');
}

include_once ('_system/autoload.inc.php');
include_once ('_system/scripthelper.inc.php');
include_once ('_system/fetchhelper.inc.php');

if (!key_exists('SEARCHDIR', $CONFIG)) {
    $s = array();
    $s['SEARCHDIR'] = 'search/';
    $CONFIG = array_merge($CONFIG, $s);
    unset($s);
}

// falls der Webmaster 0 bei $CONFIG['DAYLIVINGCAM'] eingegeben hat
// kommt es zu Fehlern, darum mindestens 12 Std.
if (isset($CONFIG['DAYLIVINGCAM']) && $CONFIG['DAYLIVINGCAM'] == 0) {
    $CONFIG['DAYLIVINGCAM'] = .5;
}
// myecho('ausfuehrende datei: '.__FILE__);
// $div_development = set_development();

// ab hier erfolgt das Holen der Daten
// aber bevor es los geht
// nachsehen ob alle Verzeichnisse erstellt und
// diese entsprechende lese- und schreibrechte haben
$install_inc_file = 'install.inc.php';
if (file_exists($install_inc_file)) {
    include_once ($install_inc_file);
}

if (!file_exists($CONFIG['TEMPDIR']."system.s")) {
    $system = array();
    $system['lastrequest'] = 0;
    $system['lastdelete'] = time();
    $system['faktor'] = 1000;
    $system['faktortime'] = 0;
    $system['searchtime'] = 0;
} else {
    $system = unserialize(implode("", file($CONFIG['TEMPDIR']."system.s")));
}
if (!isset($system['lastonline'])) {
    $system['lastonline'] = time();
}
if (!isset($system['searchtime'])) {
    $system['searchtime'] = 0;
}
if ($system['searchtime'] + 3600 < time()) {
    $system['searchtime'] = time();
    $searchfile = 1;
}
if (!isset($system['cleanuptime'])) {
    $system['cleanuptime'] = 0;
}

if (isset($_REQUEST["update"]) && $_REQUEST["update"] == 1) {
    updatecam();
}
if (isset($_REQUEST["cleanup"]) && $_REQUEST["cleanup"] == 1) {
    $system['cleanuptime'] = 0;
}
if (isset($_REQUEST["reset"]) && $_REQUEST["reset"] == 1) {
    resetcam();
}
if (isset($_REQUEST["force"]) && $_REQUEST["force"] == 1) {
    $system['lastrequest'] = 0;
}
if (isset($_REQUEST["forcedelete"]) && $_REQUEST["forcedelete"] == 1) {
    $system['lastdelete'] = 0;
}
$update = 0;
$datei = "kategorie-0.s";
if (file_exists($CONFIG['TEMPDIR'].$datei)) {
    $update = 1;
}

if (!get_kategorie_array_live($update)) {
    if ($CONFIG['CRONJOB'] == 0) {
        // ein kleines GIF anzeigen
        display_fetch_gif();
    } else {
        // die Installationsseite anzeigen
        // variables fuer die Funktion install_inc
        $hinweis = 1;
        $config_path = $CONFIG['PATH'];
        if (substr($config_path, strlen($config_path) - 1) != '/') {
            $config_path .= '/';
        }
        $link = "http://".$_SERVER["HTTP_HOST"].$config_path."fetch.php";
        $message = "Es wurden keine Daten geholt. Es lag/liegt ein tempor&auml;rer Fehler auf dem Datenserver von 777Live vor.";
        $display_link = "Bitte warten Sie ein paar Minuten und f&uuml;hren Sie dann einen neuen <a href=\"{$link}?first=1\" title=\"Script installieren und Daten importieren\">Datenimport</a> aus.";
        $display_link .= "<br/>Dieser Vorgang kann einige Minuten dauern. Nach erfolgreichem Datenimport wird direkt zur Startseite weiter geleitet.";
        // system.s abspeichern
        $file = "system.s";
        if (!savefile($file, "TEMPDIR", serialize($system))) {
            die("Datei konnte nicht gespeichert werden, bitte pr&uuml;fen Sie die Verzeichnisrechte von ".$CONFIG["TEMP"]);
        }
        // install anzeigen
        // display_install_inc($message, $link, $display_link);
        die();
    }
} else {
    setze_faktor();
    delete_old_files();
    info_mail();
}


// System und Cam abspeichern
$file = "system.s";
if (!savefile($file, "TEMPDIR", serialize($system))) {
    die("Datei konnte nicht gespeichert werden, bitte pr&uuml;fen Sie die Verzeichnisrechte von ".$CONFIG["TEMP"]);
}

if ($CONFIG['PATH'] == "/") {
    $CONFIG['PATH'] = "";
}

if (time() >= intval($system['cleanuptime'])) {
    // myecho('cleanup_func soll ausgefuehrt werden');
    cleanup_func();
    $system['cleanuptime'] = time() + (24 * 60 * 60);
    // myecho('und nun speichern system');
    savesystem();
    // myecho('system wurde gespeichert');
}

// erstellung der search.txt, tags und topsender in die functions.inc.php
// verlagert, damit dies nur gemacht wird keine fetch.php noch ausgefuehrt wird
// ausser beim ersten holen der Dateien und wenn $CONFIG['CRONJOB'] = 1
if ($CONFIG['CRONJOB'] == 1 || (isset($_GET['first']) && $_GET['first'] == 1)) {
    $make_searchfile = true;
    if (is_dir($CONFIG['SEARCHDIR'])) {
        $file = 'make_searchfile.tool.php';
        if (is_file($file)) {
            $display_status = false;
            include_once ($file);
        } else {
            $make_searchfile = false;
        }
    } else {
        $make_searchfile = false;
    }
    if (!$make_searchfile) {
        echo($file.' wurde nicht ausgefuehrt');
    }
}
// jetzt nachschauen ob von jeder Kategorie
// ab dem zweiten tag nach der Installation
// mindestens cols * rows vorhanden sind
$fillup_text_file = $docroot.$CONFIG['TEMPDIR'].'filluptimestamp.txt';
$day = 60 * 60 * 24;
if (is_file($fillup_text_file)) {
	$filled = false;
    $last_update = str_ireplace("\n", '', trim(file_get_contents($fillup_text_file)));
	if(!is_numeric($last_update)){
		$last_update = 0;
	}
	// myecho(date('Y-m-d: G:i:s', $last_update));
    if (time() - $last_update > 0) {        
        try {
            // myecho('check Fillup');
            $fill = new fillupcollection();
            $filled = $fill->getfilled();
            if (isset($fill)) {
                unset($fill);
            }
        }
        catch(Exception $e) {
            echo($e->getMessage());
            savelog($e->getMessage());
        }
        $timestamp = time() + $day;
        if (isset($CONFIG['DAYLIVINGCAM'])) {
            $timestamp = time() + ($day * $CONFIG['DAYLIVINGCAM']);
        }
        file_put_contents($fillup_text_file, $timestamp);
    }
    if ($filled) {
    	$docroot = utilities::getDocRoot();
		$script_directory = utilities::getScriptDirectory(__FILE__, 'trash/');
        $fetch_first = 'http://'.$CONFIG['DOMAIN'].$script_directory.'fetch.php?first=1';
		// echolink($fetch_first);die();
        get_content($fetch_first);
        $message = 'Kategorien wurden aufgefuellt';
    } else {
        $message = 'alles OK - kein Fillup noetig';
    }
	savelog($message);
} else {
    file_put_contents($fillup_text_file, time() + $day);
}

if (function_exists("memory_get_usage")) {
    $memory_usage = utilities::convert_memory_usage();
    savelog("Speicher: ".$memory_usage." vor exit Zeile:".__LINE__);
}
// die();

if (isset($_GET['first']) && $_GET['first'] == 1) {
    $url = "http://".$_SERVER["HTTP_HOST"];
    $config_path = $CONFIG['PATH'];
    if (substr($config_path, strlen($config_path) - 1) != '/') {
        $config_path .= '/';
    }
    $url .= $config_path;
    // myecho($url);
    header("HTTP/1.1 200 OK", true);
    header("Content-type: text/html");
    echo('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
				<head>
					<title>Weiterleitung zur Startseite</title>
					<style type="text/css" media="all">
						/*<![CDATA[*/
						@import url('.$config_path.'install.css.php?d='.urlencode($config_path).');			           
						p{
							margin:100px 0 0 100px;	
						}
						/* ]]> */
					</style>
					<script language="javascript" type="text/javascript">
						/*<![CDATA[*/
						/**
						* automatische Weiterleitung zur Startseite
						*/
						window.onload = function(){
							window.location.href=\''.$url.'\';
						}						
						/* ]]> */
					</script>
				</head>
				<body>
					<p>
					<a href="'.$url.'" target="_self" title="Startseite anzeigen">Zur Startseite</a>
					</p>
				</body>
			</html>');
    die();
}


if ($CONFIG['CRONJOB'] == 0) {
    display_fetch_gif();
}
die();
?>
