<?php 
/**
 * diese Datei ist in der function.inc.php
 * eingebunden und ueberprueft die
 * Installation von 777script
 * z. B. vorhandensein von benoetigten Verzeichnissen
 * Schreibrechte von den Verzeichnissen
 * cache, campics, google, search und temp
 * welche in der globalen Variable $CONFIG definiert wurden
 */

if (!isset($docroot)) {
    $docroot = realpath(dirname(__FILE__))."/";
    $docroot = str_ireplace(array('\\', '_system/'), array('/', ''), $docroot);
    if(!defined('DOCROOT')){
		define("DOCROOT", $docroot);
	}
}

// benoetigte PHP Dateien
include_once ('config.inc.php');
include_once ('_system/autoload.inc.php');
include_once ('_system/scripthelper.inc.php');



$config_path = $CONFIG['PATH'];
if (substr($config_path, strlen($config_path) - 1) != '/') {
    $config_path .= '/';
}
$config_popupdir = $CONFIG['POPUPDIR'];
if (substr($config_popupdir, strlen($config_popupdir) - 1) != '/') {
    $config_popupdir.'/';
}
if (!isset($messages)) {
    $messages = array();
}
if(!isset($display_link) || is_null($display_link)){
	$display_link = '';
}
if(!isset($display) || is_null($display)){
	$display = '';
}

// globaler install check wird in einer Textdatei notiert
// ob die Voraussetzungen fuer die Ausfuehrung der aktuellen Version gegeben sind
$install_display = null;
$install_check = true;
$install_check_file = $docroot.$CONFIG['TEMPDIR'].'install_check.txt';
if (!file_exists($install_check_file)) {
    $install_check = false;
    $install_display = '<div><ul><li>'.str_ireplace($docroot, '/', $install_check_file).' ist noch nicht in der aktuellen Version vorhanden.<br/>Installation wird ueberprueft, ';
    $install_display .= 'wenn keine weitere Meldung oder kein Datenimport notwendig ist - Die Seite <a href="'.$_SERVER['REQUEST_URI'].'" title="reload">reloaden</a></li></ul></div>';
    //file_put_contents($install_check_file, $CONFIG['VERSION']);
} else {
    $content = str_replace("\n", "", trim(file_get_contents($install_check_file)));
    if ($content == $CONFIG['VERSION']) {
        $install_check = true;
    } else {
        unlink($install_check_file);
    }
}
// nachsehen ob die Hosts von denen das Script Daten erhaelt erreichbar sind
if(!$install_check){
	$remote_domains = array();
	$remote_domains[] = array('host' => 'remote.777live.com', 'loc' => '/scriptservice.php');
	$remote_domains[] = array('host' => 'mm.777-partner.net', 'loc' => '/showdetail.php');
	$remote_domains[] = array('host' => '777livecams.com', 'loc' => '/remoteregister.php');
	$remote_domains[] = array('host' => '777script.777partner.com', 'loc' => '/download/info.xml');
	foreach($remote_domains as $remote_domain){
		if(!utilities::head($remote_domain['host'], $remote_domain['loc'])){
			$messages[] = $remote_domain['host'] . ' ist durch die Firewall blockiert, bitte lassen Sie die Domain durch Ihren Provider frei schalten';
		}		
	}
}


// mit der Version 7.20 muss die main.php des entsprechenden Layouts im Header UTF-8 stehen haben
// und sollte selbst auch in UTF-8 geschrieben sein, vorher muessen aber alle Sonderzeichen decoded werden
if (!$install_check) {
    $main_file_name = 'main.php';
    $layout_path = $_SERVER['DOCUMENT_ROOT'].'/'.$CONFIG['LAYOUTPATH'];
    $layout_path = str_ireplace('//', '/', $layout_path);
    if (substr($layout_path, strlen($layout_path) - 1) != '/') {
        $layout_path .= '/';
    }
    $layout_path = str_ireplace('//', '/', $layout_path);
    // jetzt noch die restlichen PHP Layout aktualisieren
    $files = scandirneu($layout_path);
    foreach ($files as $file) {
        $file = $layout_path.$file;
        // myecho($file);die();
        if (substr($file, strripos($file, '.') + 1) == 'php') {
            if (filesize($file) > 0) {
                $write_new = false;
                $content = trim(file_get_contents($file));
                if (strpos($content, 'iso-8859-1') !== false) {
                    $content = str_ireplace('iso-8859-1', 'UTF-8', $content);
                    $write_new = true;
                }
                if (!utilities::isUTF8($content)) {
                    // myecho ('TEXT ist nicht UTF8');
                    // HTML_ENTITIES entfernen
                    $content = html_entity_decode($content);
                    // Text in UTF-8 encode
                    $content = utilities::__utf8_encode($content);
                    $write_new = true;
                } else {
                    if (strpos($content, '&u') !== false) {
                        $content = html_entity_decode($content);
                        $write_new = true;
                    }
                    if (!utilities::isUTF8($content)) {
                        // Text in UTF-8 encode
                        $content = utilities::__utf8_encode($content);
                        $write_new = true;
                    }
                }
                if ($write_new) {
                	$permission = '666';
                	if (is_writable($file)) {
                        // Datei neu schreiben
                        if (!file_put_contents($file, $content)) {
                            // die Datei konnte nicht geschrieben werden
                            $messages[] = str_replace($docroot, '', $file).' konnte nicht in UTF-8 umgewandelt werden';
                        }
                    } else {
                        $messages[] = str_replace($docroot, '', $file).' konnte nicht in UTF-8 umgewandelt werden,<br/>Bitte je nach Serverkonfiguration manuell auf '.$permission.' stellen.';
                    }
                }
            }
        }
    }
    
    // jetzt noch die Textdateien im Sprachverzeichnis
    $textdir2 = $docroot.$CONFIG['TXTDIR2'];
    if (substr($textdir2, strlen($textdir2) - 1) != '/') {
        $textdir2 .= '/';
    }
    $files = scandirneu($CONFIG['TXTDIR2']);
    foreach ($files as $file) {
        if (substr($file, strripos($file, '.') + 1) == 'txt') {
            $file = $textdir2.$file;
            if (filesize($file) > 0) {
                $write_new = false;
                $content = trim(file_get_contents($file));
                if (!utilities::isUTF8($content)) {
                    // myecho ('TEXT ist nicht UTF8');
                    // HTML_ENTITIES entfernen
                    $content = html_entity_decode($content);
                    // Text in UTF-8 encode
                    $content = utilities::__utf8_encode($content);
                    $write_new = true;
                } else {
                    if (strpos($content, '&u') !== false) {
                        $content = html_entity_decode($content);
                        $write_new = true;
                    }
                    if (!utilities::isUTF8($content)) {
                        // Text in UTF-8 encode
                        $content = utilities::__utf8_encode($content);
                        $write_new = true;
                    }
                }
                if ($write_new) {
                    if (is_writable($file)) {
                        // Datei neu schreiben
                        if (!file_put_contents($file, $content)) {
                            // die Datei konnte nicht geschrieben werden
                            $messages[] = str_replace($docroot, '', $file).' konnte nicht in UTF-8 umgewandelt werden';
                        }
                    } else {
                        $messages[] = str_replace($docroot, '', $file).' konnte nicht in UTF-8 umgewandelt werden, keine Schreibrechte vorhanden';
                    }
                }
            }
        }
    }
}

// Pruefe auch gleich, ob Verzeichnisse beschreibbar sind.
$directories = array($CONFIG['TEMPDIR'], $CONFIG['IMAGEDIR'], $CONFIG['TXTDIR'], 
					$CONFIG['CACHEDIR'], $CONFIG['SEARCHDIR'], $CONFIG['SITEMAPDIR'], 
					$config_popupdir, $CONFIG['TXTDIR2'], $CONFIG['IMAGEDIR'].$CONFIG['THUMBSDIR']);
$neuhinweis = 0;

if (!isset($hinweis)) {
    $hinweis = 0;
}

$link = "http://".$_SERVER["HTTP_HOST"].$config_path."fetch.php";
if (count($messages) == 0 && strlen($display) == 0) {
    foreach ($directories as $directory) {
        $cache_dir = false;
        $campic_dir = $message = $sitemapdir = $popupdir = $layoutdir = '';
        $directory_created = false;
        switch ($directory) {
            case $CONFIG['SITEMAPDIR']:
                $sitemapdir = $CONFIG['SITEMAPDIR'];
                if (strripos($CONFIG['SITEMAPDIR'], '/') == strlen($CONFIG['SITEMAPDIR']) - 1) {
                    $sitemapdir = substr($CONFIG['SITEMAPDIR'], 0, strlen($CONFIG['SITEMAPDIR']) - 1);
                }
                $dir = substr($sitemapdir, strripos($sitemapdir, '/') + 1).'/';
                break;
            case $CONFIG['IMAGEDIR']:
                $dir = $directory;
                $campics_dir = $CONFIG['IMAGEDIR'];
                break;
            case $CONFIG['LAYOUTPATH']:
                $dir = $directory;
                $layoutdir = true;
                break;
            case $CONFIG['POPUPDIR']:
                $dir = $popupdir = $config_popupdir;
                break;
            case $CONFIG['CACHEDIR']:
                $dir = $directory;
                $cache_dir = true;
                break;
            default:
                $dir = $directory;
                
        }
        if (substr($directory, strlen($directory) - 1) != '/') {
            $directory .= '/';
        }
        if (!is_dir($directory) && empty($popupdir)) {
            // versuche ein Verzeichnis zu erstellen
            if (!@mkdir($directory, 0755)) {
                $message = '<div>Verzeichnis: <span>'.$dir.'</span> konnte nicht automatisch mit Schreibrechten erstellt werden.</div><div>Bitte manuell erstellen (Schreibrechte 755 oder 777 je nach Servereinstellung).</div>';
            } else {
                clearstatcache();
                // nachsehen ob die Schreibrechte stimmen
                $perms = fileperms($directory);
                //myecho(decoct($perms));
                $decoct = decoct($perms);
                $perm = substr($decoct, 2, strlen($decoct));
                if ($perm != 755 || $perm != 777) {
                    $message = '<div>Verzeichnis: <span>'.$dir.'</span> wurde neu erstellt.</div><div>Bitte &uuml;berpr&uuml;fen Sie es auf Schreibrechte (755 oder 777 je nach Servereinstellung).</div>';
                }
                $directory_created = true;
            }
            $hinweis = 1;
        } elseif (!is_dir($directory)) {
            // Directory fuer das Anmeldefenster ist nicht vorhanden
            $message = '<div>Verzeichnis: <span>'.$popupdir.'</span> f&uuml;r das Anmeldefenster ist nicht vorhanden.</div>';
            $message .= '<div>Bitte laden Sie ben&ouml;tigten Dateien f&uuml;r das Anmeldefenster aus der ZIP-Datei des Basis-Moduls auf Ihren Server.</div>';
        }
        if (!is_dir($directory) && ! empty($layoutdir)) {
            // myecho($directory);
            $message = '<div>Verzeichnis: <span>'.$dir.'</span> ist nicht Vorhanden</div>';
            $url = '//777script.777partner.com/download.php?id='.$CONFIG['WMID'].'&amp;f='.$CONFIG['LAYOUT'];
            $message .= '<div>Bitte laden Sie ben&ouml;tigten Dateien f&uuml;r das Layout 
			<a href="'.$url.'" title="ZIP Layout download" target="_self">HIER</a> und<br/>
			senden Sie die entpackten Dateien in das Layoutverzeichnis auf Ihren Server.</div>';
        }
        if ($layoutdir === '') {
            if (is_dir($directory) && !is_writable($directory) && empty($popupdir)) {
                $perms = fileperms($directory);
                //myecho(decoct($perms));
                $decoct = decoct($perms);
                $perm = substr($decoct, 2, strlen($decoct));
                if ($perm != 755 || $perm != 777) {                    
                    $message = '<div>Verzeichnis: <span>'.$dir.'</span> ist nicht beschreibbar.</div><div>Bitte je nach Serverkonfiguration manuell auf 777 oder 755 stellen.</div>';
                }
            }
        }
        //
        // Verzeichnis fuer die sitemap -> standardmaessig google
        // auf Dateien und beschreibbarkeit ueberpruefen
        if ($CONFIG['SITEMAP'] == 1 && ! empty($sitemapdir) && $directory_created) {
            $message = '';
            if (!create_testfile($directory)) {
                $message = '<div>Verzeichnis: <span>'.$dir.'</span> konnte nicht mit Schreibrechten automatisch erstellt werden.</div><div>Bitte manuell mit Schreibrechten (755 oder 777 je nach Servereinstellung) erstellen.</div>';
            }
        }
        //
        if (is_dir($directory) && empty($sitemapdir) && $directory != $CONFIG['TXTDIR'] && $directory_created) {
            $message = '';
            if ($directory != $CONFIG['CACHEDIR']) {
                if (!search_in_directory($directory)) {
                    $message = '<div>Im Verzeichnis: <span>'.$dir.'</span> ';
                    switch ($dir) {
                        case $CONFIG['IMAGEDIR']:
                            $message .= 'fehlen Setupdateien vom Script</div><div>Bitte die Setupdateien neu laden.</div>';
                            break;
                        case 'search/':
                            $message .= 'fehlen Dateien zur Suche und Tag Erstellung</div><div>Bitte einen Datenimport durchf&uuml;hren.</div>';
                            break;
                        default:
                            $message = '';
                    }
                    if (!create_testfile($directory)) {
                        $message = '<div>Verzeichnis: <span>'.$dir.'</span> konnte nicht mit Schreibrechten automatisch erstellt werden.</div><div>Bitte manuell mit Schreibrechten (755 oder 777 je nach Servereinstellung) erstellen.</div>';
                    }
                }
            } else if ($directory == $CONFIG['CACHEDIR'] && $CONFIG['CACHE'] != 0) {
                if (!create_testfile($directory)) {
                    $message = '<div>Verzeichnis: <span>'.$dir.'</span> konnte nicht mit Schreibrechten automatisch erstellt werden.</div><div>Bitte manuell mit Schreibrechten (755 oder 777 je nach Servereinstellung) erstellen.</div>';
                }
            }
        }
        if (! empty($message)) {
        	$messages[] = $message;
            if ( empty($display_link)) {
                if (!$cache_dir) {
                    $display_link = "Damit alle relvanten Daten zur Ausf&uuml;hrung von 777Script zur Verf&uuml;gung stehen, 
        							f&uuml;hren Sie bitte den <a href=\"{$link}?first=1\" title=\"Script installieren und Daten importieren\" class=\"a_data_import\">Datenimport</a> aus.
        							<br/>
        							Dieser Vorgang kann einige Minuten dauern. Nach erfolgreichem Datenimport wird direkt zur Startseite weiter geleitet.";
                }
            }
        }
    }
    if ( empty($display_link)) {
        $display_link = '&nbsp;';
    }
    // Ende ueberpruefung Verzeichnisse
    $kindofhinweis = array();
    $hinweis = 1;
    if ( empty($display_link)) {
        $hinweis = 0;
    }
	
	$system_file = $CONFIG['TEMPDIR']."system.s";
	
    if (!file_exists($system_file)) {
        $hinweis = 1;
        // nur einmal die Sicherheitseinstellungen pruefen
        if ($CONFIG['SECURE'] != 0 && $CONFIG['SECURE'] != "OFF") {
            if (ini_get('safe_mode') != 1 && strtolower(ini_get('safe_mode')) != "on") {
                //    echo ini_get('safe_mode');
                $hinweis = 1;
                $kindofhinweis['safe_mode'] = 1;
            } elseif (ini_get('register_globals') != 0 && strtolower(ini_get('register_globals')) != "off") {
                //    echo ini_get('register_globals');
                $hinweis = 1;
                $kindofhinweis['register_globals'] = 1;
            } elseif (ini_get('allow_url_include') == 1 || strtolower(ini_get('allow_url_include')) == "on") {
                //    echo ini_get('allow_url_include');
                $hinweis = 1;
                $kindofhinweis['allow_url_include'] = 1;
            }
        }
        // vielleicht soll die fetch.php ausgefuehrt werden
        // darum auf Paramenter ueberpruefen
        $keys = array('call', 'first', 'force');
        $call_fetch = false;
        if (count($messages) == 0) {
            foreach ($keys as $key) {
                if (key_exists($key, $_REQUEST)) {
                    $hinweis = 0;
                    $call_fetch = true;
                    break;
                }
            }
        }
        
        if (count($kindofhinweis) > 0 && !$call_fetch) {
        
            $display = "<div id=\"div_attention\"><p>Aus Sicherheitsgr&uuml;nden sollte das Script nur mit nachfolgenden Einstellungen betrieben werden:</p>";
            $display .= "<p style=\"font-family:Courier New;\">- safe_mode<span style=\"margin-left:55px;\"> = ON</span> &nbsp;| Status bei Ihnen ".((isset($kindofhinweis['safe_mode'])) ? "<span style=\"color:red\">OFF</span>" : "<span style=\"color:green\">OFF</span>")."<br />";
            $display .= "- register_globals<span style=\"margin-left:6px;\"> = OFF</span> | Status bei Ihnen ".((isset($kindofhinweis['register_globals'])) ? "<span style=\"color:red\">ON</span>" : "<span style=\"color:green\">OFF</span>")."<br />";
            $display .= "- allow_url_include = OFF | Status bei Ihnen ".((isset($kindofhinweis['allow_url_include'])) ? "<span style=\"color:red\">ON</span>" : "<span style=\"color:green\">OFF</span>")."</p>";
            $display .= "<p>Sollten bei der Installation des 777Scripts oben genannte PHP-Einstellungen nicht stimmen, sprechen Sie bitte mit Ihrem Provider, in den meisten F&auml;llen sollte es m&ouml;glich sein, die Einstellungen herzustellen.</p>";
            
            $display .= "<p>Auch wenn wir grunds&auml;tzlich den Betrieb des 777Scripts nur mit aktivierten Sicherheitsmodulen empfehlen, ";
            $display .= "kann das 777script auch ohne Sicherheitsmodule verwendet werden.<br/>(Sicherheitsmodul deaktivieren: Datei config.inc.php den Wert *<span style=\"color:green\">\$CONFIG[\"SECURE\"] = 1;</span>* ";
            
            //$display .= "Sollten Sie eine &Auml;nderung w&uuml;nschen,  Sie direkt in der Datei 'config.inc.php' (Hauptverzeichnis) nachfolgende Einstellung:<br />";
            //$display .= "<br/>";
            //$display .= '$CONFIG["SECURE"] = 1;<br/>';
            //$display .= "<br/>";
            $display .= "=> von 1 auf 0 &auml;ndern)</p></div>";
            $hinweis = 1;
        }
        if ($hinweis == 1) {
            if ( empty($display)) {
                $display = 'Datenimport';
            }
            $display_link = "Damit alle relvanten Daten zur Ausf&uuml;hrung von 777Script zur Verf&uuml;gung stehen, 
							f&uuml;hren Sie bitte den <a href=\"{$link}?first=1\" title=\"Script installieren und Daten importieren\" class=\"a_data_import\">Datenimport</a> aus.
							<br/>
							Dieser Vorgang kann einige Minuten dauern. Nach erfolgreichem Datenimport wird direkt zur Startseite weiter geleitet.";
							
        }
        
    } elseif (filesize($system_file) == 0) {
    	
        unlink($system_file);
		$link = "http://".$_SERVER["HTTP_HOST"].$CONFIG['PATH']."/fetch.php";
        $messages[] = "Der vorhandene Webspace scheint voll zu sein. Es k&ouml;nnen leider keine Daten angezeigt werden";
		$messages[] = "Bitte &uuml;berfr&uuml;fen Sie in wie weit Ihnen noch Webspace zur Verf&uuml;gung steht";
		$messages[] = "Wenn Sie keinen Webspace mehr frei haben, pr&uuml;fen, ob es &uuml;berfl&uuml;ssige Dateien gibt, die Sie l&ouml;schen k&ouml;nnten ( z. B. /cache/ leeren) oder sprechen Sie mit Ihrem Provider f&uuml;r die Anpassung des Speicherplatzes";
		$messages[] = "Sollte es nach dem n&auml;chsten Versuch Daten zu importieren, wieder zu einer Fehlermeldung kommen, kontaktieren Sie bitte unseren <a href=\"https://www.777partner.com/impressum.php/\" title=\"Kontakt\" target=\"_blank\">Support</a>";
		$display_link = "F&uuml;hren Sie bitte einen <a href=\"{$link}?first=1&amp;force=1\" target=\"_self\" title=\"Nach Speicherplatzerweiterung ausf&uuml;hren\"  class=\"a_data_import\">Datenimport</a> aus.";
    }
}
// Install check Textfile evtl. schreiben
if (count($messages) == 0) {
	$install_display = '';
    if (!file_exists($install_check_file)) {
        file_put_contents($install_check_file, $CONFIG['VERSION']);
		$install_check = true;
    }
} else {
    if (is_file($install_check_file)) {
        unlink($install_check_file);
    }
}

if (count($messages) > 0 || ! empty($display) || !$install_check) {
    if ($CONFIG['USEIMPRESSUM'] == 1) {
        // DIV mit Impressum anzeigen
        $display_impressum = true;
    }
    $display_impressum = false;
    if (!headers_sent()) {
        header("HTTP/1.1 500 Internal Server Error", true);
        header('Content-type: text/html; charset=UTF-8');
    }
    

?>
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <title>Installation von 777script</title>
        <meta name="description" content="Installation 777script" />
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
        <script src="<?=$config_path ?>javascript.js" type="text/javascript">
        </script>
        <style type="text/css" media="all">        
            /*<![CDATA[*/
			@import url(<?= $config_path ?>install.css.php?d=<?= urlencode($config_path) ?>);
			/* ]]> */
        </style>
    </head>
    <body>
        <?php 
        if ($display_impressum) {
            
        ?>
        <div class="div_impressum" id="div_impressum">
            <div class="div_close" onmouseover="changeStyle(this, new Array(new Array('backgroundColor', '#FFF'), new Array('color', '#F00')));" onmouseout="changeStyle(this, new Array(new Array('backgroundColor', '#F00'), new Array('color', '#FFF')));" title="schliessen" onclick="displayObject('div_impressum');">
                X
            </div>
            <div>
                <?php 
                echo $CONFIG['IMPREssUM_TEXT'];
                ?>
            </div>
        </div>
        <?php 
        }
        ?>
        <div class="div_content" id="div_content">
            <?php 
            $u = 0;
            if (! empty($display) || $display_link == '&nbsp;' || !$install_check) {
                
            ?>
            <div>
                <h2>Installation des 777scripts</h2>
                <hr/>
            </div>
            <?php 
            }
			if(!empty($install_display)){
				echo($install_display);
			}
            $u = 0;
            if (count($messages) > 0) {
                $u++;
                
            ?>
            <div>
                <h3 class="h3_infoheadline"><?php echo($u)?>. Schritt / Systempr&uuml;fung</h3>
                <ul>
                    <?php 
                    foreach ($messages as $message) {
                        echo('<li>'.$message.'</li>');
                    }
                    ?>
                </ul>
            </div>
            <?php 
            }			
            if ((! empty($display) && $display != 'Datenimport')) {
                $u++;
                echo('<div><h3 class="h3_infoheadline" style="margin-top:25px;">'.$u.'. Schritt / Sicherheitseinstellungen &uuml;berpr&uuml;fen</h3>'.$display.'</div>');
            }
            if (! empty($display_link) && $display_link != '&nbsp;') {
                $u++;
                echo('<div><h3 class="h3_infoheadline" style="margin-top:25px;">'.$u.'. Schritt / Datenimport</h3><p>'.$display_link.'</p></div>');
            }
            ?>
            <hr/><h3 style="color:#000;">Hinweise f&uuml;r den Webmaster</h3>
            <div>
                <?php 
                if ($CONFIG['WMID'] == 'A10000') {
                    echo('<span style="color:#F00;">A10000 ist als $CONFIG[\'WMID\'] eingestellt.</span> Bitte &auml;ndern Sie diese in Ihre Webmaster- oder Projektid.');
                }
                ?>
            </div>
            <div style="margin:5px 0 5px 0;">
                Ausf&uuml;hrliche Informationen zur Installation sowie Tipps und Tricks finden Sie unter <a href="//scriptdoku.777partner.com/" target="_blank" title="Script Installation">http://scriptdoku.777partner.com/</a>
            </div>
            <?php 
            if (count($messages) > 0 || ! empty($display)) {
                
            ?>
            <hr style="margin:20px 0 0 0;"/>
            <div class="div_email" align="center">
                <h2 style="color:#000;">Diese Website befindet sich im Moment im Aufbau</h2>
                <h3 style="color:#000;">Lust auf Erotik? <a href="//777livecams.com/?id=<?=$CONFIG['WMID'] ?>&amp;l=<?=$CONFIG['LIVECAMLAYOUT'] ?>&amp;h=<?=$sticky['header'] ?>" title="Livecams" target="_blank">Extrem hei&szlig;e und nackte Tatsachen  - HIER KLICKEN</a></h3>
            </div>
            <?php 
            }
            ?>
            <div class="div_footer" id="div_footer">
                <!--
                <a href="//777partner.com/?id=<?=$CONFIG['WMID'] ?>" title="Geld verdienen" target="_blank">Partner werden und $$ Geld verdienen $$</a>
                |
                &copy; 777Systems N.V 2005 -
                <?= date('Y', time()) ?>
                | <a href="//777livecams.com/?id=<?=$CONFIG['WMID'] ?>&amp;l=<?=$CONFIG['LIVECAMLAYOUT'] ?>&amp;h=<?=$sticky['header'] ?>" title="Livecams" target="_blank">Livecams</a> |
                -->
                <?php 
                if ($display_impressum) {
                    
                ?>
                <a href="javascript:void(0);" target="_self" title="Impressum anzeigen" onclick="displayObject('div_impressum');">Impressum</a>
                <?php 
                }
                ?>
            </div>
        </div>
        <script language="javascript" type="text/javascript">
            /*<![CDATA[*/
            var display_impressum = false;
            var display_attension = false;
            function windowsize(){
                if (self.innerHeight) {
                    this.x = self.innerWidth;
                    this.y = self.innerHeight;
                }
                else 
                    if (document.documentElement && document.documentElement.clientHeight) {
                        this.x = document.documentElement.clientWidth;
                        this.y = document.documentElement.clientHeight;
                    }
                    else 
                        if (document.body) {
                            this.x = document.body.clientWidth;
                            this.y = document.body.clientHeight;
                        }
            }
            
            function displayObject(objId){
                if (document.getElementById(objId) != undefined) {
                    var objDiv = document.getElementById(objId);
                    var display = null;
                    switch (objId) {
                        case 'div_impressum':
                            display = display_impressum;
                            break;
                        case 'div_attention':
                            display = display_attension;
                            break;
                        default:
                            return false;
                    }
                    if (!display) {
                        objDiv.style.display = 'block';
                        objDiv.style.visibility = 'visible';
                    }
                    else {
                        objDiv.style.display = 'none';
                        objDiv.style.visibility = 'hidden';
                    }
                    if (display) {
                        display = false;
                    }
                    else {
                        display = true;
                    }
                    switch (objId) {
                        case 'div_impressum':
                            display_impressum = display;
                            break;
                        case 'div_attention':
                            display_attension = display;
                            break;
                        default:
                            return false;
                    }
                }
            }
            
            function changeStyle(obj, array){
                var objStyle = obj.style;
                var text = '';
                for (i = 0, n = array.length; i < n; i++) {
                    var item = array[i];
                    var name = item[0];
                    var value = item[1];
                    text += ' ' + name + '\n';
                    switch (name) {
                        case 'backgroundColor':
                            objStyle.backgroundColor = value;
                            break;
                        case 'color':
                            objStyle.color = value;
                            break;
                        case 'display':
                            objStyle.display = value;
                            break;
                        case 'visibility':
                            objStyle.visibility = value;
                            break;
                        default:
                    }
                }
                //alert(text);
            }
            
            window.onload = function(){
                var wz = new windowsize();
                var objDiv = document.getElementById('div_content');
                var objHeight = objDiv.offsetHeight;
                var objWidth = objDiv.offsetWidth;
                var sLeft = Math.ceil((parseInt(wz.x) - parseInt(objWidth)) / 2);
                var sTop = Math.ceil((parseInt(wz.y) - parseInt(objHeight)) / 2) - 30;
                // DIV fast mittig setzen
                if (sTop > 0) {
                    objDiv.style.top = sTop + 'px';
                }
                if (sLeft > 0) {
                    objDiv.style.left = sLeft + 'px';
                }
            }
            /* ]]> */
        </script>
    </body>
</html>
<?php 
die();
} else {
    unset($messages);
    unset($display);
    unset($link);
    unset($display_link);
    unset($message);
}
?>