<?php 

@set_time_limit(120);
require_once ("config.inc.php");
include_once ('_system/autoload.inc.php');
include_once ('_system/scripthelper.inc.php');
include_once ('_system/fetchhelper.inc.php');
try {
    $dateiname = "search.txt";
    $tagdateiname = "tag.txt";
    $counttagwords = 20;
    
    /* *****************************************
     * Ab hier sollte man nichts mehr aendern.
     */
    
    if (!key_exists('SEARCHDIR', $CONFIG)) {
        $s = array();
        $s['SEARCHDIR'] = 'search/';
        $CONFIG = array_merge($CONFIG, $s);
        unset($s);
    }
    
    $tempdir = $CONFIG['TEMPDIR'];
    $textdir = $CONFIG['TXTDIR'];
    $searchdir = $CONFIG['SEARCHDIR'];
    
    // die Datei sollte nicht zuoft geaendert werden
    // ich wuerde sie alle 24 Stunden aendern
    $lastupdate = 0;
    $time_diff = 60 * 25;
    if (key_exists('renew', $_GET) && $_GET['renew'] == 1) {
        $time_diff = 0;
    }
    $lastupdate_filename = 'timestamp_search.txt';
    if (substr($tempdir, strlen($tempdir) - 1) != '/') {
        $lastupdatefile = $tempdir.'/timestamp_search.txt';
    } else {
        $lastupdatefile = $tempdir.'timestamp_search.txt';
    }
    if (file_exists($lastupdatefile) && filesize($lastupdatefile) > 0) {
        $fp = fopen($lastupdatefile, 'r');
        $lastupdate = trim(str_replace("\n", "", fread($fp, filesize($lastupdatefile))));
        fclose($fp);
    }
    if (!is_numeric($lastupdate)) {
        echo('Es konnten keine Suchdateien erstellt werden, weil die Zeit des letzten Updates nicht ausgelesen werden konnte');
        die();
    }
    
    if (time() - $lastupdate > $time_diff) {
        /* *****************************************
         * Aus welchen Feldern sollen die Suchbegriffe genommen werden?
         * Benutzen Sie folgende Wildcards:
         * (WICHTIG: Nicht immer sind alle Felder besetzt, das sollte man beruecksichtigen)
         * {name}
         * {geschlecht}
         * {sternzeichen}
         * {alter}
         * {sexpref}
         * {haarfarbe}
         * {augenfarbe}
         * {gewicht}
         * {groesse}
         * {nation}
         * {hobbies}
         * {piercing}
         * {figur}
         * {haarlaenge}
         * {koerbchengroesse}
         * {intimrasur}
         * {hautfarbe}
         * {beschreibung}
         * {plz}
         * {shortdescription}
         * {charakter}
         * {sprachen}
         * {erointressen}
         */
        
        // Nachfolgende Felder werden bei der jetzigen Tagerstellung nicht beruecksichtigt
        
        $array_keys = array('NAME', 'ONLINE', 'DISABLED', 'SETCARDLANG', 'CAMID', 'GESCHLECHT', 'SHORTDESCRIPTION', 'BESCHREIBUNG', 'STERNZEICHEN', 'ALTER', 'SEXPREF', 'HAARFARBE', 'AUGENFARBE', 'GEWICHT', 'GRoessE', 'NATION', 'PIERCING', 'FIGUR', 'HAARLaeNGE', 'KoeRBCHENGRoessE', 'INTIMRASUR', 'HAUTFARBE', 'PLZ', 'PREVIEW', 'GALERIE', 'EROINTREssEN_ONE', 'SPRACHEN');
        $stopwords = array("ab", "aber", "aehnlich", "aehnlich", "alle", "allein", "allem", "aller", "alles", "allg", "allgemein", "als", "also", "am", "an", "and", "andere", "anderen", "anderes", "auch", "auf", "aus", "ausser", "author", "autor", "been", "bei", "beim", "bereits", "besonders", "bevor", "bietet", "bin", "bis", "bist", "boeden", "boeden", "bzw", "da", "dabei", "dadurch", "dafuer", "daher", "damit", "dann", "daran", "darauf", "daraus", "darum", "das", "dass", "davon", "davor", "dazu", "dein", "deine", "dem", "den", "denen", "denn", "dennoch", "der", "derem", "deren", "des", "deshalb", "dessen", "die", "dies", "diese", "diesem", "diesen", "dieser", "dieses", "dinge", "doch", "dort", "du", "dunklen", "durch", "eben", "eher", "eigenen", "eigenes", "ein", "eine", "einem", "einen", "einer", "eines", "einfach", "einig", "einige", "er", "erst", "erste", "erster", "es", "etc", "etwa", "etwas", "euer", "eure", "fall", "finden", "for", "fuer", "ganz", "ganze", "ganzem", "ganzen", "ganzer", "ganzes", "gar", "geben", "gegen", "geht", "gibt", "gleich", "gute", "guten", "habe", "haben", "hat", "hatte", "hatten", "hattest", "hattet", "hier", "hinter", "ich", "ihm", "ihr", "ihre", "ihrem", "ihren", "ihrer", "ihres", "im", "immer", "in", "information", "ist", "ja", "je", "jede", "jedem", "jeden", "jeder", "jedes", "jedoch", "jene", "jenem", "jenen", "jener", "jenes", "jetzt", "kann", "kannst", "kein", "keine", "keinem", "keinen", "keiner", "keines", "koennen", "koennt", "kommen", "kommt", "koennen", "koennt", "langsam", "lassen", "leicht", "leider", "lichten", "machen", "man", "mehr", "mehrere", "mein", "meine", "meist", "mich", "mit", "moechte", "moechte", "moeglich", "moeglich", "muessen", "muesst", "muss", "musst", "nach", "nachdem", "natuerlich", "neben", "nein", "neu", "neue", "neuem", "neuen", "neuer", "neues", "nicht", "nichts", "noch", "nun", "nur", "nutzung", "ob", "oder", "off", "ohne", "online", "per", "schnell", "schon", "schwierig", "sehen", "sehr", "sehrwohl", "seid", "sein", "seine", "seinem", "seinen", "seiner", "seines", "seit", "seite", "seiten", "selber", "selbst", "sich", "sie", "sind", "so", "sodass", "solch", "solche", "solchem", "solchen", "solcher", "solches", "soll", "sollen", "sollst", "sollt", "sollte", "sollten", "solltest", "sonst", "soviel", "soweit", "sowie", "sowohl", "spielen", "statt", "steht", "suchen", "ueber", "um", "und", "uns", "unser", "unsere", "unseren", "unseres", "unter", "version", "viel", "viele", "vieles", "vom", "von", "vor", "wachen", "wann", "war", "warum", "was", "weiter", "weitere", "welche", "welchem", "welchen", "welcher", "welches", "wenig", "wenige", "weniger", "wenn", "wer", "werde", "werden", "werdet", "weshalb", "wie", "wieder", "wieso", "wieviel", "wir", "wird", "wirklich", "wirst", "wo", "woher", "wohin", "wohl", "wurde", "wurden", "zu", "zum", "zur", "zwischen", "the");

        
        $content_search_by_show_names = ''; // Shownamen werden in einer extra Datei gespeichert

        
        // tempverzeichnis nach XML-Dateien der Cams auslesen und diese in ein Array einfuegen
        $files = array();
        if ($handle = opendir($tempdir)) {
            while ($file = readdir($handle)) {
                // Es muss sich um ein xml-File handeln, der vorderer Teil muss numerisch sein:
                if ($file != "." && $file != ".." && strlen($file) > 5 && strpos($file, '.') !== false && substr($file, strripos($file, '.') + 1) == 'xml') {
                    $file_name = substr($file, 0, strripos($file, '.'));
                    if (is_numeric($file_name)) {
                        $compl = $tempdir."/".$file;
                        $files[filemtime($compl)] = $file;
                    }
                }
            }
            closedir($handle);
        } else {
            throw new Exception($tempdir.' konnte nicht ausgelesen werden');
        }
        if (count($files) == 0) {
            throw new Exception('In '.$tempdir.' sind keine XML-Dateien mit Camdaten enthalten');
        }
        // Datteien nach aenderungsdatum sortieren
        krsort($files);
        $time_limit = 60;
        $max_count_stop = null;
        $max_count = 0;
        $time_limit = ini_get('max_execution_time');
        // myecho($time_limit);
        if (is_numeric($time_limit) && $time_limit < 60) {
            $max_count_stop = 750;
            if (function_exists('savelog')) {
                savelog('max_execution_time fuer make_searchfile.tool.php bitte auf 60 Sekunden stellen lassen, damit alle XML-Dateien aufgenommen werden');
            }
        }
        $slc = new searchLineCollection();
        foreach ($files as $file) {
            $xml_file = $tempdir.$file;
            $showid = substr($file, 0, strripos($file, '.'));
            $xml = implode("", file($tempdir.$file));
            $array = xml2array($xml);
            // nachsehen ob nicht disabled
            $valid = true;
            if (!isset($array['DISABLED']) || $array['DISABLED'] == 1) {
                $valid = false;
            }
            // darf die Show ueberhaupt noch angezeigt werden
            if (!key_exists('DISPLAY', $array) || (key_exists('DISPLAY', $array) && $array['DISPLAY'] == 0)) {
                $valid = false;
            }
			if(isset($CONFIG['DAYLIVINGCAM'])){
				if (time() - filemtime($tempdir.$file) > (60 * 60 * 24 * $CONFIG['DAYLIVINGCAM'])) {
	                $valid = false;
	            }	
			}            
            // nachsehen ob gueltige Bilder
            if ($valid && key_exists('PREVIEW', $array) && is_array($array['PREVIEW'])) {
                foreach ($array['PREVIEW'] as $preview) {
                    $image_id = image_id($preview);
                    if (is_numeric($image_id) && strlen($image_id) >= 7) {
                        // alles ok
                    } else {
                        $valid = false;
                        break;
                    }
                }
            } else {
                $valid = false;
            }
            if ($valid) {
                //myecho($array['CAMID']); flush();
                $content_search_by_show_names .= $array['NAME'].'='.$array['CAMID']."\n";
                for ($i = 0, $n = count($array_keys); $i < $n; $i++) {
                    if (isset($array[$array_keys[$i]])) {
                        $array[$array_keys[$i]] = '';
                    }
                }
                $text = '';
                foreach ($array as $entry) {
                    $text .= ' '.$entry;
                }
                // Auseinander nehmen
                $worte = preg_split("/[\n\r\t \.\,\;\?\(\)\!\"\'\:\+]+/", $text);
                foreach ($worte as $wort) {
                    $wort = trim(strtolower($wort));
                    if (!is_numeric($wort) && (preg_match("/^([a-zaeueoess][a-zaeueoess-]+[a-zaeueoess])$/", $wort, $regs) && strlen($wort) > 2 && strlen($wort) < 16) && !in_array($wort, $stopwords)) {
                        $searchline = new searchLine($wort, array($showid));
                        $slc->add($searchline);
                    }
                }
                if (!is_null($max_count_stop)) {
                    if ($max_count >= $max_count_stop) {
                        break;
                    }
                    $max_count++;
                }
            }
        }
        $slc->createLines();
        $taglines = $slc->getTagTextlines();
        $searchlines = $slc->getSearchTextlines();
        $list = $slc->getList();
        // myecho($list);
        // myecho($searchlines);
        // myecho($taglines);
        if (isset($slc)) {
            unset($slc);
        }
        $tagcontent = '';
        $i = 0;
        foreach ($taglines as $tagline) {
            $i++;
            if (trim($tagline) != '') {
                $tagcontent .= $tagline;
                if ($i < count($taglines)) {
                    $tagcontent .= "\n";
                }
            }
        }
        $searchcontent = '';
        $i = 0;
        foreach ($searchlines as $searchline) {
            $i++;
            if (trim($searchline) != '') {
                $searchcontent .= $searchline;
                if ($i < count($searchlines)) {
                    $searchcontent .= "\n";
                }
            }
        }
        $valid = true;
        $failed_file = '';
        // searchbyshownames.txt speichern
        if (!savefile('searchbyshownames.txt', 'SEARCHDIR', $content_search_by_show_names)) {
            $failed_file = $searchdir.'searchbyshownames.txt';
            $valid = false;
        }
        // search.txt speichern
        if ($valid && !savefile($dateiname, 'SEARCHDIR', $searchcontent)) {
            $failed_file = $searchdir.$dateiname;
            $valid = false;
        }
        // tag.txt speichern
        if ($valid && !savefile($tagdateiname, 'SEARCHDIR', $tagcontent)) {
            $failed_file = $searchdir.$tagdateiname;
            $valid = false;
        }
        // lastupdate speichern
        if ($valid && !savefile($lastupdate_filename, 'TEMPDIR', time())) {
            $failed_file = $tempdir.$lastupdate_filename;
            $valid = false;
        }
        // Statusmeldung
        if ($valid) {
            $message = $_SERVER['SCRIPT_NAME'].' => hat neue Suchindexdateien wurden erstellt';
        } else {
            $message = $_SERVER['SCRIPT_NAME'].' => konnte '.$failed_file.' nicht erstellen';
        }
    } else {
        // Status ausgeben
        $message = substr(__FILE__, strripos(__FILE__, '/')).' => Suchindexdateien mussten nicht erneuert werden';
    }
    
}
catch(Exception $e) {
    $message = $e->getMessage();
}

// loggen wenn moeglich
if (function_exists('savelog')) {
    savelog($message);
}
if (!isset($display_status)) {
    echo($message);
}
?>