<?php 
/*****************************************************
 *                                                   *
 *  777Script Version 8.1                           *
 *  make_sitemap.tool.php V. 1.1                     *
 *  Diese Datei sollte nicht veraendert werden.      *
 *                                                   *
 *****************************************************/
 
require_once ("config.inc.php");
include_once ('_system/scripthelper.inc.php');
include_once ('_system/autoload.inc.php');
/**
 @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 @@@                                                 @@@
 @@@ WICHTIGER HINWEIS:                              @@@
 @@@                                                 @@@
 @@@ Die nachfolgende Variable:                      @@@
 @@@ $CONFIG['NUMBER-OF-RECEIVING-URLS']             @@@
 @@@ gehoert zur Datei urllist_cleanup.tool.php      @@@
 @@@ und erstellt die Datei urllist.txt bzw.		 @@@
 @@@ liest diese aus					 			 @@@
 @@@                                                 @@@
 @@@ Sie kennt drei verschiedene Zustaende:          @@@
 @@@ -1 bedeutet, das Tool uebernimmt keine          @@@
 @@@    Sedcard-URLs aus der filelist.dir,           @@@
 @@@    sondern erstellt fuer jede                   @@@
 @@@    Sedcard nur eine URL aus der Hauptkategorie  @@@
 @@@    fuer die Sitemap							 @@@
 @@@    // tja da wird noch dran gearbeitet			 @@@
 @@@                                                 @@@
 @@@ 0  bedeutet, das Tool erstellt keine            @@@
 @@@    urllist.txt, bei der Sitemap werden			 @@@
 @@@	"nur Urls" aus der filelist.dir verwendet	 @@@
 @@@										         @@@
 @@@ 1 und groesser                                  @@@
 @@@    bedeutet, das Tool uebernimmt aus der        @@@
 @@@	filelist.dir und urllist.txt 				 @@@
 @@@	die in $CONFIG['NUMBER-OF-RECEIVING-URLS']   @@@
 @@@    definierte Anzahl von 						 @@@
 @@@	Sedcard-URLs eines Senders.       			 @@@
 @@@                                                 @@@
 @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
*/


if (!function_exists('urllist')) {
    function urllist() {
        global $CONFIG,$CATLINKZ,$CAMLINKZ;
        $anzahlalt = 0;
        // Es muss die temporaere Fileliste geben.
        $sitemap_tempfile = $CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-TEMPFILE'];
        if (!is_file($sitemap_tempfile)) {
            echo($sitemap_tempfile.' ist nicht vorhanden');
            return false;
        }
        $links = file($sitemap_tempfile);
        @unlink($sitemap_tempfile);
        
        // Erweitere alle links um die Domain und entferne \n
        if (is_array($links) && count($links) > 0) {
            for ($n = 0; $n < count($links); $n++) {
                $links[$n] = trim($CONFIG['SITEMAP-DOMAIN'].$links[$n]);
            }
        } else {
            return false;
        }
        
        // Jetzt muss die urllist dazu kommen
        @ini_set('memory_limit', '32M');
        $linksalt = array();
        $urllist_file = $CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-URLLIST'].".txt";
        if (is_file($urllist_file)) {
            $content = file_get_contents($urllist_file);
            $content = replace_double_line_breaks($content);
            if (strpos($content, "\n") !== false) {
                $linksalt = preg_split("#\n#", $content);
            }
            // myecho($linksalt);
            // entferne \n
            $links_from_urllist = array();
            if (is_array($linksalt) && count($linksalt) > 0) {
                for ($n = 0; $n < count($linksalt); $n++) {
                    if (! empty($linksalt[$n])) {
                        // myecho($linksalt[$n]);
                        $linksalt[$n] = str_replace(array("\n", "\t", "\r"), array('', '', ''), $linksalt[$n]);
                        if (strpos($linksalt[$n], $CONFIG['SITEMAP-DOMAIN']) !== false && strpos($linksalt[$n], '.php/') === false) {
                            $links_from_urllist[] = trim($linksalt[$n]);
                        }
                    }
                }
                $anzahlalt = count($links_from_urllist);
            }
            if (count($links_from_urllist) > 0) {
                $links = array_merge($links, $links_from_urllist);
            }
        }
        // myecho($links_from_urllist);
        // Seiten mit 404-Fehler entfernen:
        if (is_file($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-404'])) {
            $l404 = file($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-404']);
            @unlink($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-404']);
            if (is_array($l404) && count($l404) > 0) {
                for ($n = 0; $n < count($l404); $n++) {
                    $l404[$n] = trim($l404[$n]);
                }
                $links = array_diff($links, $l404);
            }
        }
        
        $ereg_liste = array();
        if (is_array($CONFIG['SITEMAP-DISALLOW-TEXT']) && count($CONFIG['SITEMAP-DISALLOW-TEXT']) > 0) {
            foreach ($CONFIG['SITEMAP-DISALLOW-TEXT'] as $ausdruck) {
                $ereg_liste[] = "(".$ausdruck.")";
            }
        }
        if (is_array($CONFIG['SITEMAP-DISALLOW-ONEND']) && count($CONFIG['SITEMAP-DISALLOW-ONEND']) > 0) {
            foreach ($CONFIG['SITEMAP-DISALLOW-ONEND'] as $ausdruck) {
                $ereg_liste[] = "(".$ausdruck."$)";
            }
        }
        $ereg_liste = implode("|", $ereg_liste);
        
        sort($links);
        $linksneu = array();
        $alt = "";
        for ($n = 0; $n < count($links); $n++) {
            if ($alt != $links[$n]) {
                $alt = $links[$n];
                if (!preg_match("#".$ereg_liste."#", $links[$n])) {
                    $linksneu[count($linksneu)] = $links[$n];
                }
            }
        }
        $links = $cam_ids = array();
		$anzahlneu = 0;
        if (count($linksneu) > 0) {
            // wenn moeglich die ID von den Sedcards herausfiltern, damit keine doppelten Eintraege entstehen
            foreach ($linksneu as $link) {
                $cam_id = -1;
                $url = trim(str_ireplace('http://'.$CONFIG['DOMAIN'], '', $link));
                // myecho($url);
                $url = substr($url, strpos($url, '/') + 1);
                // myecho($url);
                if (strpos($url, '/') !== false) {
                    $url_parts = explode("/", $url);
                } else {
                    $url_parts = array($url);
                }
                // myecho($url_parts);
                for ($n = 0; $n < count($url_parts); $n++) {
                    $found = false;
                    $url_parts[$n] = preg_replace("/\D/", "", $url_parts[$n]);
                    if (! empty($url_parts[$n]) && is_numeric($url_parts[$n]) && $url_parts[$n] > 1) {
                        // myecho('url_part:'.$url_parts[$n]);
                        $xml_file_name = $url_parts[$n].'.xml';
                        $xml_file = $CONFIG['TEMPDIR'].$xml_file_name;
                        if (is_file($xml_file)) {
                            $cam_id = $url_parts[$n];
                            break;
                        }
                    }
                }
                if ($cam_id > - 1) {
                    if (!in_array($cam_id, $cam_ids)) {
                        $cam_ids[] = $cam_id;
						$links[] = $link;
                        // myecho($cam_id. ' link wird eingetragen: '.$link);
                    } else {
                       // myecho($cam_id.' ist schon in einem anderer URL vorhanden');
                    }
                } else {
                    // myecho('keine camid gefunden ('.$cam_id.') - '.$link.' wird aufgenommen');
                    $links[] = $link;
                }
            }
        }
        // myecho($links);
        if (count($links) > 0) {
            // Dann wieder abspeichern
            $anzahlneu = count($links) - $anzahlalt;
			if($CONFIG['NUMBER-OF-RECEIVING-URLS'] != 0){
				$fp = fopen($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-URLLIST'].".txt", "w");
	            $all_links = implode("\n", $links);
	            fputs($fp, $all_links);
	            fclose($fp);
	            @chmod($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-URLLIST'].".txt", 0666);
	            
	            $fp = fopen($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-URLLIST'].".txt.gz", "w");
	            $gz_links = gzip($all_links, 9);
	            fputs($fp, $gz_links);
	            fclose($fp);
	            @chmod($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-URLLIST'].".txt.gz", 0666);	
			}
            //  jetzt die Sitemap erstellen
            baue_sitemap($links);
        }
		// myecho($anzahlneu);
        return $anzahlneu;
    }
}

if (!function_exists('baue_sitemap')) {
    function baue_sitemap($links) {
        global $CONFIG;
        reset($links);
        // Erst alle Sitemapindexe anlegen.
        $xml = '<?xml version="1.0" encoding="UTF-8" ?>
		<sitemapindex xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">'."\n";
		
        $xml_gz = $xml;
        $wieviel = intval(count($links) / $CONFIG['SITEMAP-ANZAHL']) + 1;
        $sitemapdir = str_replace(DOCROOT, '/', $CONFIG['SITEMAPDIR']);
		$script_directory = $CONFIG['HOME'];
		$directory = str_ireplace('//', '/', $script_directory.$sitemapdir);
        for ($n = 1; $n < $wieviel + 1; $n++) {
            $linkintern = $CONFIG['SITEMAP-DOMAIN'].$directory.$CONFIG['SITEMAP-NAME-SITEMAP'].$n.".xml";
            $xml .= '   <sitemap>'."\n";
            $xml .= '      <loc>'.$linkintern.'</loc>'."\n";
            $xml .= '      <lastmod>'.date("Y-m-d").'</lastmod>'."\n";
            $xml .= '   </sitemap>'."\n";
            $linkintern = $CONFIG['SITEMAP-DOMAIN'].$directory.$CONFIG['SITEMAP-NAME-SITEMAP'].$n.".xml.gz";
            $xml_gz .= '   <sitemap>'."\n";
            $xml_gz .= '      <loc>'.$linkintern.'</loc>'."\n";
            $xml_gz .= '      <lastmod>'.date("Y-m-d").'</lastmod>'."\n";
            $xml_gz .= '   </sitemap>'."\n";
        }
        $xml .= '</sitemapindex>'."\n";
        $xml_gz .= '</sitemapindex>'."\n";
        $fp = fopen($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-SITEMAP'].".xml", "w");
        fputs($fp, $xml);
        fclose($fp);
        @chmod($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-SITEMAP'].".xml", 0666);
        
        $fp = fopen($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-SITEMAP'].".xml.gz", "w");
        $xml_gz = gzip($xml_gz, 9);
        fputs($fp, $xml_gz);
        fclose($fp);
        @chmod($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-SITEMAP'].".xml.gz", 0666);
        
        $zeile = 0;
        for ($n = 1; $n < $wieviel + 1; $n++) {
            $xml = '<?xml version="1.0" encoding="UTF-8" ?>
			<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">'."\n";
            for ($m = 0; $m < $CONFIG['SITEMAP-ANZAHL']; $m++) {
                if (isset($links[$zeile]) && $links[$zeile] != "") {
                    $url = trim($links[$zeile]);
                    $datum = date("Y-m-d\TH:i:s+00:00");
                    $xml .= '<url><loc>'.$url.'</loc><lastmod>'.$datum.'</lastmod></url>'."\n";
                    $zeile++;
                }
            }
            $xml .= '</urlset>'."\n";
            $fp = fopen($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-SITEMAP'].$n.".xml", "w");
            fputs($fp, $xml);
            fclose($fp);
            @chmod($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-SITEMAP'].$n.".xml", 0666);
            
            $fp = fopen($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-SITEMAP'].$n.".xml.gz", "w");
            $xml_gz = gzip($xml, 9);
            fputs($fp, $xml_gz);
            fclose($fp);
            @chmod($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-SITEMAP'].$n.".xml.gz", 0666);
        }
        return true;
    }
}

if (!function_exists('gzip')) {
    function gzip($data = "", $level = 6, $filename = "", $comments = "") {
        $flags = ( empty($comment) ? 0 : 16) + ( empty($filename) ? 0 : 8);
        $mtime = time();
        return (pack("C1C1C1C1VC1C1", 0x1f, 0x8b, 8, $flags, $mtime, 2, 0xFF).( empty($filename) ? "" : $filename."\0").( empty($comment) ? "" : $comment."\0").gzdeflate($data, $level).pack("VV", crc32($data), strlen($data)));
    }
}

if (!function_exists('savelog')) {
    function savelog($text) {
        global $CONFIG;
        if ($CONFIG['LOG'] < 1) {
            return true;
        }
        if ($fp = @fopen($CONFIG['TEMPDIR']."log.txt", "a")) {
            fputs($fp, date("H:i:s d.m.Y")." - ".__FILE__." - ".$text."\n");
            fclose($fp);
            @chmod($CONFIG['TEMPDIR']."log.txt", 0666);
        }
    }
}

$neu = urllist();
// myecho(("Es wurden weitere ".$neu." Links in die Sitemap eingetragen."));
savelog("Es wurden weitere ".$neu." Links in die Sitemap eingetragen.");
if (isset($exit) && !$exit) {
    // nichts mit Feierabend
} else {
    exit();
}
?>