<?php 

include_once ("config.inc.php");
include_once ('_system/scripthelper.inc.php');


if (!function_exists('notsedcards')) {
    function notsedcards() {
        global $CONFIG,$CAMLINKZ;
        
        $camlinkpos = 0;
        for ($n = 0; $n < count($CAMLINKZ); $n++) {
            if (strpos(trim($CAMLINKZ[$n]), "{id}") !== false) {
                $camlinkpos = $n;
            }
        }
        // $CAMLINKZ[$camlinkpos] muss maskiert werden.
        $ausdruck = str_replace("{id}", "[0-9]{1,6}", $CAMLINKZ[$camlinkpos]);
        $ausdruck = "\/".$ausdruck;
        if ($n < count($CAMLINKZ) + 1) {
            $ausdruck = $ausdruck."\/";
        }
        // Lade nun die urllist.txt
        $neuurllist = "";
        if (file_exists($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-URLLIST'].".txt")) {
            $fp = fopen($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-URLLIST'].".txt", "r");
            while (!feof($fp)) {
                $zeile = trim(fgets($fp));
                // Untersuche die zeile, ob es eine Sedcard ist oder eine
                if (!preg_match("`".$ausdruck."`", $zeile, $treffer)) {
                    $neuurllist .= $zeile."\n";
                }
            }
            fclose($fp);
        }
        return $neuurllist;
    }
}
if (!function_exists('onlysedcards')) {
    function onlysedcards($number) {
        global $CONFIG,$CAMLINKZ;
        $sedcards = array();
        $camlinkpos = 0;
        for ($n = 0; $n < count($CAMLINKZ); $n++) {
            if (strpos(trim($CAMLINKZ[$n]), "{id}") !== false) {
                $camlinkpos = $n;
            }
        }
        // $CAMLINKZ[$camlinkpos] muss maskiert werden.
        $ausdruck = str_replace("{id}", "[0-9]{1,6}", $CAMLINKZ[$camlinkpos]);
        $ausdruck = "\/".$ausdruck;
        if ($n < count($CAMLINKZ) + 1) {
            $ausdruck = $ausdruck."\/";
        }
        // Lade nun die urllist.txt
        $neuurllist = "";
        if (file_exists($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-URLLIST'].".txt")) {
            $fp = fopen($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-URLLIST'].".txt", "r");
            while (!feof($fp)) {
                $zeile = trim(fgets($fp));
                // Untersuche die zeile, ob es eine Sedcard ist oder eine
                if (preg_match("`".$ausdruck."`", $zeile, $treffer)) {
                    if (preg_match("/(\d{1,6})/", $treffer[0], $neutreffer)) {
                        $camid = $neutreffer[0];
                        if (!isset($sedcards[$camid]) || $sedcards[$camid] < $number) {
                            if (isset($sedcards[$camid])) {
                                $sedcards[$camid]++;
                            } else {
                                $sedcards[$camid] = 1;
                            }
                            $neuurllist .= $zeile."\n";
                        }
                    }
                }
            }
            fclose($fp);
        }
        return $neuurllist;
    }
}
if (!function_exists('getAllIds')) {
    function getAllIds() {
        // Hole alle Sedcards
        global $CONFIG;
        $sedcard = array();
        $dateien = scandirneu($CONFIG['TEMPDIR']);
        if (count($dateien)) {
            for ($n = 0; $n < count($dateien); $n++) {
                if (is_file($CONFIG['TEMPDIR'].$dateien[$n])) {
                    // $dateien[$n] im TEMPDIR darf nur eine Cam sein, also hinten .xml und vorne eine Zahl!
                    $endung = substr($dateien[$n], -4);
                    $vorne = substr($dateien[$n], 0, -4);
                    if ($endung == ".xml" && is_numeric($vorne)) {
                        $sedcard[] = $vorne;
                    }
                }
            }
        }
        return $sedcard;
    }
}

if (!function_exists('get_cam_info')) {
    function get_cam_info($sid) {
        global $CONFIG;
        // Ah, es gibt eine Cam, hole deren Daten
        $xml_datei = $CONFIG['TEMPDIR'].$sid.".xml";
        
        // Es kann natuerlich sein, dass der/die Sender nicht online ist
        // also sieh einmal nach, ob die Daten nicht im temporaeren Ordner sind.
        $sender = array();
        if (file_exists($xml_datei)) {
            $dateibuffer = implode("\n", file($xml_datei));
            $sender = xml2array($dateibuffer);
        }
        return $sender;
    }
}

if (!function_exists('getLink')) {
    function getLink($camid) {
        global $CONFIG,$CAMLINKZ,$kategorie;
        if ($CONFIG['PATH'] == "") {
            $CONFIG['PATH'] = "/";
        }
        $helplink = $CONFIG['PATH'].implode("/", $CAMLINKZ);
        $camlink = $helplink;
        $caminfo = get_cam_info($camid);
        $keyword1 = keyword1($camid);
        $keyword2 = keyword2($camid);
        $keyword3 = keyword3($camid);
        $sk = senderkey($camid);
        $camlink = str_replace("{kategorie}", $kategorie[0]["linkname"], $camlink);
        $camlink = str_replace("{senderkey}", $sk, $camlink);
        $camlink = str_replace("{id}", $camid, $camlink);
        $camlink = str_replace("{keyword1}", $keyword1, $camlink);
        $camlink = str_replace("{keyword2}", $keyword2, $camlink);
        $camlink = str_replace("{keyword3}", $keyword3, $camlink);
        $camlink = str_replace("{desc}", urlencode(replace_ltext(substr($caminfo['BESCHREIBUNG'], 0, 60))), $camlink);
        $camlink = str_replace("{name}", urlencode(replace_ltext($caminfo['NAME'])), $camlink);
        return $camlink;
    }
}


if ($CONFIG['SITEMAP'] && file_exists($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-URLLIST'].".txt")) {
    $urllistneu = notsedcards();
    // Hole alle xml-Sedcard-id
    if ($CONFIG['NUMBER-OF-RECEIVING-URLS'] == -1) {
        $cams = getAllIds();
        if (count($cams)) {
            foreach ($cams as $key) {
                $cam_link = $CONFIG['SITEMAP-DOMAIN'].getLink($key);
                if (! empty($cam_link)) {
                    $urllistneu .= $cam_link."\n";
                }
                
            }
        }
    } elseif ($CONFIG['NUMBER-OF-RECEIVING-URLS'] == 0) {
        // Es gibt hier nichts zu tun.
    } elseif ($CONFIG['NUMBER-OF-RECEIVING-URLS'] > 0 && $CONFIG['NUMBER-OF-RECEIVING-URLS'] < 20) {
        $urllistneu .= onlysedcards($CONFIG['NUMBER-OF-RECEIVING-URLS']);
    } else {
        echo 'Die Variable $CONFIG[\'NUMBER-OF-RECEIVING-URLS\'] hat einen nicht akzepablen Wert.';
        exit;
    }
    if (! empty($urllistneu)) {
        $fp = fopen($CONFIG['SITEMAPDIR'].$CONFIG['SITEMAP-NAME-URLLIST'].".txt", "w");
        fputs($fp, $urllistneu);
        fclose($fp);
    }
}

if (!isset($exit) || $exit != false) {
    exit;
}
?>